#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "ocl.h"

#include "app.h"

struct C** c_instances = NULL;
int c_size = 0;

struct D** d_instances = NULL;
int d_size = 0;

struct C** newCList(void)
{ return (struct C**) calloc(ALLOCATIONSIZE, sizeof(struct C*)); }

struct D** newDList(void)
{ return (struct D**) calloc(ALLOCATIONSIZE, sizeof(struct D*)); }

int getC_x(struct C* self) { return self->x; }

char* getC_s(struct C* self) { return self->s; }

struct D* getC_dr(struct C* self) { return self->dr; }

void setC_x(struct C* self, int _value) { self->x = _value; }

void setC_s(struct C* self, char* _value) { self->s = _value; }

void setC_dr(struct C* self, struct D* _value) { self->dr = _value; }

int* getAllC_x(struct C* _col[])
{ int n = length((void**) _col);
  int* result = (int*) calloc(n, sizeof(int));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getC_x(_col[i]); }
  return result;
}

char** getAllC_s(struct C* _col[])
{ int n = length((void**) _col);
  char** result = (char**) calloc(n+1, sizeof(char*));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getC_s(_col[i]); }
  result[n] = NULL;
  return result;
}

struct D** getAllC_dr(struct C* _col[])
{ int n = length((void**) _col);
  struct D** result = (struct D**) calloc(n+1, sizeof(struct D*));
  int i = 0;
  for ( ; i < n; i++)
  { result[i] = getC_dr(_col[i]); }
  result[n] = NULL;
  return result;
}

struct C** appendC(struct C* col[], struct C* ex)
   { struct C** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct C**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct C*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

struct D** appendD(struct D* col[], struct D* ex)
   { struct D** result;
     int len = length((void**) col);
     if (len % ALLOCATIONSIZE == 0)
     { result = (struct D**) calloc(len + ALLOCATIONSIZE + 1, sizeof(struct D*));
       int i = 0;
       for ( ; i < len; i++) { result[i] = col[i]; }
     }
     else { result = col; }
     result[len] = ex;
     result[len+1] = NULL;
     return result;
   }

void addC(void* obj)
{ c_instances = appendC(c_instances, (struct C*) obj);
  c_size++;
}

void addD(void* obj)
{ d_instances = appendD(d_instances, (struct D*) obj);
  d_size++;
}

struct C* createC(void)
{ struct C* result = (struct C*) malloc(sizeof(struct C));
  result->x = 0;
  result->s = NULL;
  result->dr = NULL;
  addC(result);
  return result;
}

struct D* createD(void)
{ struct D* result = (struct D*) malloc(sizeof(struct D));
  addD(result);
  return result;
}

struct C** insertC(struct C* col[], struct C* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendC(col,self);
  }

struct D** insertD(struct D* col[], struct D* self)
  { if (isIn((void*) self, (void**) col))
    { return col; }
    return appendD(col,self);
  }

  struct C** subrangeC(struct C** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct C** result = (struct C**) calloc(j - i + 2, sizeof(struct C*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct D** subrangeD(struct D** col, int i, int j)
  { int len = length((void**) col);
    if (i < 1) { i = 1; }
    if (j > len) { j = len; }
    if (i > j) { return NULL; }
    struct D** result = (struct D**) calloc(j - i + 2, sizeof(struct D*));
    int k = i-1;
    int l = 0;
    for ( ; k < j; k++, l++)
    { result[l] = col[k]; }
    result[l] = NULL;
    return result;
  }

  struct C** reverseC(struct C** col)
  { int n = length((void**) col);
    struct C** result = (struct C**) calloc(n+1, sizeof(struct C*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

  struct D** reverseD(struct D** col)
  { int n = length((void**) col);
    struct D** result = (struct D**) calloc(n+1, sizeof(struct D*));
    int i = 0;
    int x = n-1;
    for ( ; i < n; i++, x--)
    { result[i] = col[x]; }
    result[n] = NULL;
    return result;
  }

struct C** removeC(struct C* col[], struct C* ex)
{ int len = length((void**) col);
  struct C** result = (struct C**) calloc(len+1, sizeof(struct C*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct C* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct D** removeD(struct D* col[], struct D* ex)
{ int len = length((void**) col);
  struct D** result = (struct D**) calloc(len+1, sizeof(struct D*));
  int j = 0;
  int i = 0;
  for ( ; i < len; i++)
  { struct D* _e = col[i];
    if (_e == NULL)
    { result[j] = NULL;
      return result; 
    }
    if (_e == ex) { }
    else
    { result[j] = _e; j++; }
  }
  result[j] = NULL;
  return result;
}

struct C** removeAllC(struct C* _col1[], struct C* _col2[])
{ int n = length((void**) _col1);
  struct C** result = (struct C**) calloc(n+1, sizeof(struct C*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct C* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct D** removeAllD(struct D* _col1[], struct D* _col2[])
{ int n = length((void**) _col1);
  struct D** result = (struct D**) calloc(n+1, sizeof(struct D*));
  int i = 0; int j = 0;
  for ( ; i < n; i++)
  { struct D* ex = _col1[i];
    if (isIn((void*) ex, (void**) _col2)) {}
    else 
    { result[j] = ex; j++; }
  }
  result[j] = NULL;
  return result;
}

struct C** frontC(struct C* _col[])
{ int n = length((void**) _col);
  return subrangeC(_col, 1, n-1); }

struct D** frontD(struct D* _col[])
{ int n = length((void**) _col);
  return subrangeD(_col, 1, n-1); }

struct C** tailC(struct C* _col[])
{ int n = length((void**) _col);
  return subrangeC(_col, 2, n); }

struct D** tailD(struct D* _col[])
{ int n = length((void**) _col);
  return subrangeD(_col, 2, n); }

void killC(struct C* c_x)
{ c_instances = removeC(c_instances, c_x); 
  free(c_x); 
}

void killD(struct D* d_x)
{ d_instances = removeD(d_instances, d_x); 
  struct C** c_dr_deleted = NULL; 
  int ind_boundedloopstatement_34 = 0;
  int size_boundedloopstatement_34 = length((void**) c_instances);
  for ( ; ind_boundedloopstatement_34 < size_boundedloopstatement_34; ind_boundedloopstatement_34++)
  { struct C* c_xx = (c_instances)[ind_boundedloopstatement_34];
    if (getC_dr(c_xx) == d_x)
  { setC_dr(c_xx, NULL); 
  c_dr_deleted = insertC(c_dr_deleted, c_xx);  }   } 
  int ind_boundedloopstatement_60 = 0;
  int size_boundedloopstatement_60 = length((void**) c_dr_deleted);
  for ( ; ind_boundedloopstatement_60 < size_boundedloopstatement_60; ind_boundedloopstatement_60++)
  { struct C* c_xx = (c_dr_deleted)[ind_boundedloopstatement_60];
    killC(c_xx);   } 
  free(c_dr_deleted); 
  free(d_x); 
}

int main(int _argc, char* _argv[]) { return 0; }
