import java.util.List;
import java.util.Date;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;

import java.lang.*;
import java.lang.reflect.*;
import java.util.StringTokenizer;
import java.io.*;



abstract class Expression
  implements SystemTypes
{
  protected List incoming = new Vector(); // of Edge
  protected List outgoing = new Vector(); // of Edge

  public Expression()
  {

  }



  public String toString()
  { String _res_ = "(Expression) ";
    return _res_;
  }



  public void setincoming(List incoming_xx) { incoming = incoming_xx;
    }
 
  public void addincoming(Edge incoming_xx) { if (incoming.contains(incoming_xx)) {} else { incoming.add(incoming_xx); }
    }
 
  public void removeincoming(Edge incoming_xx) { Vector _removedincomingincoming_xx = new Vector();
  _removedincomingincoming_xx.add(incoming_xx);
  incoming.removeAll(_removedincomingincoming_xx);
    }

  public static void setAllincoming(List expressions, List _val)
  { for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      Controller.inst().setincoming(expressionx, _val); } }

  public static void addAllincoming(List expressions, Edge _val)
  { for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      Controller.inst().addincoming(expressionx,  _val); } }


  public static void removeAllincoming(List expressions,Edge _val)
  { for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      Controller.inst().removeincoming(expressionx, _val); } }


  public static void unionAllincoming(List expressions, List _val)
  { for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      Controller.inst().unionincoming(expressionx, _val); } }


  public static void subtractAllincoming(List expressions,  List _val)
  { for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      Controller.inst().subtractincoming(expressionx,  _val); } }


  public void setoutgoing(List outgoing_xx) { outgoing = outgoing_xx;
    }
 
  public void addoutgoing(Edge outgoing_xx) { if (outgoing.contains(outgoing_xx)) {} else { outgoing.add(outgoing_xx); }
    }
 
  public void removeoutgoing(Edge outgoing_xx) { Vector _removedoutgoingoutgoing_xx = new Vector();
  _removedoutgoingoutgoing_xx.add(outgoing_xx);
  outgoing.removeAll(_removedoutgoingoutgoing_xx);
    }

  public static void setAlloutgoing(List expressions, List _val)
  { for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      Controller.inst().setoutgoing(expressionx, _val); } }

  public static void addAlloutgoing(List expressions, Edge _val)
  { for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      Controller.inst().addoutgoing(expressionx,  _val); } }


  public static void removeAlloutgoing(List expressions,Edge _val)
  { for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      Controller.inst().removeoutgoing(expressionx, _val); } }


  public static void unionAlloutgoing(List expressions, List _val)
  { for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      Controller.inst().unionoutgoing(expressionx, _val); } }


  public static void subtractAlloutgoing(List expressions,  List _val)
  { for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      Controller.inst().subtractoutgoing(expressionx,  _val); } }


  public List getincoming() { return (Vector) ((Vector) incoming).clone(); }

  public static List getAllincoming(List expressions)
  { List result = new Vector();
    for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      result = Set.union(result, expressionx.getincoming()); }
    return result; }

  public static List getAllOrderedincoming(List expressions)
  { List result = new Vector();
    for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      result = Set.union(result, expressionx.getincoming()); }
    return result; }

  public List getoutgoing() { return (Vector) ((Vector) outgoing).clone(); }

  public static List getAlloutgoing(List expressions)
  { List result = new Vector();
    for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      result = Set.union(result, expressionx.getoutgoing()); }
    return result; }

  public static List getAllOrderedoutgoing(List expressions)
  { List result = new Vector();
    for (int _i = 0; _i < expressions.size(); _i++)
    { Expression expressionx = (Expression) expressions.get(_i);
      result = Set.union(result, expressionx.getoutgoing()); }
    return result; }


}


class BasicExpression
  extends Expression
  implements SystemTypes
{
  private String name = ""; // internal
  private String value = ""; // internal
  private List traces$MergeBasicExpr$be = new Vector(); // of MergeBasicExpr$trace
  private List traces$MergeBasicExpr$be1 = new Vector(); // of MergeBasicExpr$trace
  private List traces$CopyBasicExpr$be = new Vector(); // of CopyBasicExpr$trace

  public BasicExpression()
  {
    this.name = "";
    this.value = "";

  }



  public String toString()
  { String _res_ = "(BasicExpression) ";
    _res_ = _res_ + name + ",";
    _res_ = _res_ + value;
    return _res_ + super.toString();
  }

  public static BasicExpression parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    BasicExpression basicexpressionx = new BasicExpression();
    basicexpressionx.name = (String) _line1vals.get(0);
    basicexpressionx.value = (String) _line1vals.get(1);
    return basicexpressionx;
  }


  public void writeCSV(PrintWriter _out)
  { BasicExpression basicexpressionx = this;
    _out.print("" + basicexpressionx.name);
    _out.print(" , ");
    _out.print("" + basicexpressionx.value);
    _out.println();
  }


  public void setname(String name_x) { name = name_x;  }


    public static void setAllname(List basicexpressions,String val)
  { for (int i = 0; i < basicexpressions.size(); i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(i);
      Controller.inst().setname(basicexpressionx,val); } }


  public void setvalue(String value_x) { value = value_x;  }


    public static void setAllvalue(List basicexpressions,String val)
  { for (int i = 0; i < basicexpressions.size(); i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(i);
      Controller.inst().setvalue(basicexpressionx,val); } }


  public void settraces$MergeBasicExpr$be(List traces$MergeBasicExpr$be_xx) { traces$MergeBasicExpr$be = traces$MergeBasicExpr$be_xx;
    }
 
  public void addtraces$MergeBasicExpr$be(MergeBasicExpr$trace traces$MergeBasicExpr$be_xx) { if (traces$MergeBasicExpr$be.contains(traces$MergeBasicExpr$be_xx)) {} else { traces$MergeBasicExpr$be.add(traces$MergeBasicExpr$be_xx); }
    }
 
  public void removetraces$MergeBasicExpr$be(MergeBasicExpr$trace traces$MergeBasicExpr$be_xx) { Vector _removedtraces$MergeBasicExpr$betraces$MergeBasicExpr$be_xx = new Vector();
  _removedtraces$MergeBasicExpr$betraces$MergeBasicExpr$be_xx.add(traces$MergeBasicExpr$be_xx);
  traces$MergeBasicExpr$be.removeAll(_removedtraces$MergeBasicExpr$betraces$MergeBasicExpr$be_xx);
    }

  public static void setAlltraces$MergeBasicExpr$be(List basicexpressions, List _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().settraces$MergeBasicExpr$be(basicexpressionx, _val); } }

  public static void addAlltraces$MergeBasicExpr$be(List basicexpressions, MergeBasicExpr$trace _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().addtraces$MergeBasicExpr$be(basicexpressionx,  _val); } }


  public static void removeAlltraces$MergeBasicExpr$be(List basicexpressions,MergeBasicExpr$trace _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().removetraces$MergeBasicExpr$be(basicexpressionx, _val); } }


  public static void unionAlltraces$MergeBasicExpr$be(List basicexpressions, List _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().uniontraces$MergeBasicExpr$be(basicexpressionx, _val); } }


  public static void subtractAlltraces$MergeBasicExpr$be(List basicexpressions,  List _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().subtracttraces$MergeBasicExpr$be(basicexpressionx,  _val); } }


  public void settraces$MergeBasicExpr$be1(List traces$MergeBasicExpr$be1_xx) { traces$MergeBasicExpr$be1 = traces$MergeBasicExpr$be1_xx;
    }
 
  public void addtraces$MergeBasicExpr$be1(MergeBasicExpr$trace traces$MergeBasicExpr$be1_xx) { if (traces$MergeBasicExpr$be1.contains(traces$MergeBasicExpr$be1_xx)) {} else { traces$MergeBasicExpr$be1.add(traces$MergeBasicExpr$be1_xx); }
    }
 
  public void removetraces$MergeBasicExpr$be1(MergeBasicExpr$trace traces$MergeBasicExpr$be1_xx) { Vector _removedtraces$MergeBasicExpr$be1traces$MergeBasicExpr$be1_xx = new Vector();
  _removedtraces$MergeBasicExpr$be1traces$MergeBasicExpr$be1_xx.add(traces$MergeBasicExpr$be1_xx);
  traces$MergeBasicExpr$be1.removeAll(_removedtraces$MergeBasicExpr$be1traces$MergeBasicExpr$be1_xx);
    }

  public static void setAlltraces$MergeBasicExpr$be1(List basicexpressions, List _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().settraces$MergeBasicExpr$be1(basicexpressionx, _val); } }

  public static void addAlltraces$MergeBasicExpr$be1(List basicexpressions, MergeBasicExpr$trace _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().addtraces$MergeBasicExpr$be1(basicexpressionx,  _val); } }


  public static void removeAlltraces$MergeBasicExpr$be1(List basicexpressions,MergeBasicExpr$trace _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().removetraces$MergeBasicExpr$be1(basicexpressionx, _val); } }


  public static void unionAlltraces$MergeBasicExpr$be1(List basicexpressions, List _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().uniontraces$MergeBasicExpr$be1(basicexpressionx, _val); } }


  public static void subtractAlltraces$MergeBasicExpr$be1(List basicexpressions,  List _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().subtracttraces$MergeBasicExpr$be1(basicexpressionx,  _val); } }


  public void settraces$CopyBasicExpr$be(List traces$CopyBasicExpr$be_xx) { traces$CopyBasicExpr$be = traces$CopyBasicExpr$be_xx;
    }
 
  public void addtraces$CopyBasicExpr$be(CopyBasicExpr$trace traces$CopyBasicExpr$be_xx) { if (traces$CopyBasicExpr$be.contains(traces$CopyBasicExpr$be_xx)) {} else { traces$CopyBasicExpr$be.add(traces$CopyBasicExpr$be_xx); }
    }
 
  public void removetraces$CopyBasicExpr$be(CopyBasicExpr$trace traces$CopyBasicExpr$be_xx) { Vector _removedtraces$CopyBasicExpr$betraces$CopyBasicExpr$be_xx = new Vector();
  _removedtraces$CopyBasicExpr$betraces$CopyBasicExpr$be_xx.add(traces$CopyBasicExpr$be_xx);
  traces$CopyBasicExpr$be.removeAll(_removedtraces$CopyBasicExpr$betraces$CopyBasicExpr$be_xx);
    }

  public static void setAlltraces$CopyBasicExpr$be(List basicexpressions, List _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().settraces$CopyBasicExpr$be(basicexpressionx, _val); } }

  public static void addAlltraces$CopyBasicExpr$be(List basicexpressions, CopyBasicExpr$trace _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().addtraces$CopyBasicExpr$be(basicexpressionx,  _val); } }


  public static void removeAlltraces$CopyBasicExpr$be(List basicexpressions,CopyBasicExpr$trace _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().removetraces$CopyBasicExpr$be(basicexpressionx, _val); } }


  public static void unionAlltraces$CopyBasicExpr$be(List basicexpressions, List _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().uniontraces$CopyBasicExpr$be(basicexpressionx, _val); } }


  public static void subtractAlltraces$CopyBasicExpr$be(List basicexpressions,  List _val)
  { for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      Controller.inst().subtracttraces$CopyBasicExpr$be(basicexpressionx,  _val); } }


    public String getname() { return name; }

    public static List getAllname(List basicexpressions)
  { List result = new Vector();
    for (int i = 0; i < basicexpressions.size(); i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(i);
      if (result.contains(basicexpressionx.getname())) { }
      else { result.add(basicexpressionx.getname()); } }
    return result; }

    public static List getAllOrderedname(List basicexpressions)
  { List result = new Vector();
    for (int i = 0; i < basicexpressions.size(); i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(i);
      result.add(basicexpressionx.getname()); } 
    return result; }

    public String getvalue() { return value; }

    public static List getAllvalue(List basicexpressions)
  { List result = new Vector();
    for (int i = 0; i < basicexpressions.size(); i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(i);
      if (result.contains(basicexpressionx.getvalue())) { }
      else { result.add(basicexpressionx.getvalue()); } }
    return result; }

    public static List getAllOrderedvalue(List basicexpressions)
  { List result = new Vector();
    for (int i = 0; i < basicexpressions.size(); i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(i);
      result.add(basicexpressionx.getvalue()); } 
    return result; }

  public List gettraces$MergeBasicExpr$be() { return (Vector) ((Vector) traces$MergeBasicExpr$be).clone(); }

  public static List getAlltraces$MergeBasicExpr$be(List basicexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      result = Set.union(result, basicexpressionx.gettraces$MergeBasicExpr$be()); }
    return result; }

  public static List getAllOrderedtraces$MergeBasicExpr$be(List basicexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      result = Set.union(result, basicexpressionx.gettraces$MergeBasicExpr$be()); }
    return result; }

  public List gettraces$MergeBasicExpr$be1() { return (Vector) ((Vector) traces$MergeBasicExpr$be1).clone(); }

  public static List getAlltraces$MergeBasicExpr$be1(List basicexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      result = Set.union(result, basicexpressionx.gettraces$MergeBasicExpr$be1()); }
    return result; }

  public static List getAllOrderedtraces$MergeBasicExpr$be1(List basicexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      result = Set.union(result, basicexpressionx.gettraces$MergeBasicExpr$be1()); }
    return result; }

  public List gettraces$CopyBasicExpr$be() { return (Vector) ((Vector) traces$CopyBasicExpr$be).clone(); }

  public static List getAlltraces$CopyBasicExpr$be(List basicexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      result = Set.union(result, basicexpressionx.gettraces$CopyBasicExpr$be()); }
    return result; }

  public static List getAllOrderedtraces$CopyBasicExpr$be(List basicexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(_i);
      result = Set.union(result, basicexpressionx.gettraces$CopyBasicExpr$be()); }
    return result; }

    public void tau$cleanup1()
  {     List pre_traces$MergeBasicExpr$be14 = new Vector();
    pre_traces$MergeBasicExpr$be14.addAll(traces$MergeBasicExpr$be);
    List pre_traces$CopyBasicExpr$be15 = new Vector();
    pre_traces$CopyBasicExpr$be15.addAll(traces$CopyBasicExpr$be);
  if ((pre_traces$MergeBasicExpr$be14.size() == 0) && (pre_traces$CopyBasicExpr$be15.size() == 0)) 
  { Controller.inst().killBasicExpression(this);}
  }


}


class BinaryExpression
  extends Expression
  implements SystemTypes
{
  private String operator = ""; // internal
  private List traces$MergeBinaryExpr$bx = new Vector(); // of MergeBinaryExpr$trace
  private List traces$MergeBinaryExpr$bx1 = new Vector(); // of MergeBinaryExpr$trace
  private List traces$CopyBinaryExpr$bx = new Vector(); // of CopyBinaryExpr$trace

  public BinaryExpression()
  {
    this.operator = "";

  }



  public String toString()
  { String _res_ = "(BinaryExpression) ";
    _res_ = _res_ + operator;
    return _res_ + super.toString();
  }

  public static BinaryExpression parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    BinaryExpression binaryexpressionx = new BinaryExpression();
    binaryexpressionx.operator = (String) _line1vals.get(0);
    return binaryexpressionx;
  }


  public void writeCSV(PrintWriter _out)
  { BinaryExpression binaryexpressionx = this;
    _out.print("" + binaryexpressionx.operator);
    _out.println();
  }


  public void setoperator(String operator_x) { operator = operator_x;  }


    public static void setAlloperator(List binaryexpressions,String val)
  { for (int i = 0; i < binaryexpressions.size(); i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(i);
      Controller.inst().setoperator(binaryexpressionx,val); } }


  public void settraces$MergeBinaryExpr$bx(List traces$MergeBinaryExpr$bx_xx) { traces$MergeBinaryExpr$bx = traces$MergeBinaryExpr$bx_xx;
    }
 
  public void addtraces$MergeBinaryExpr$bx(MergeBinaryExpr$trace traces$MergeBinaryExpr$bx_xx) { if (traces$MergeBinaryExpr$bx.contains(traces$MergeBinaryExpr$bx_xx)) {} else { traces$MergeBinaryExpr$bx.add(traces$MergeBinaryExpr$bx_xx); }
    }
 
  public void removetraces$MergeBinaryExpr$bx(MergeBinaryExpr$trace traces$MergeBinaryExpr$bx_xx) { Vector _removedtraces$MergeBinaryExpr$bxtraces$MergeBinaryExpr$bx_xx = new Vector();
  _removedtraces$MergeBinaryExpr$bxtraces$MergeBinaryExpr$bx_xx.add(traces$MergeBinaryExpr$bx_xx);
  traces$MergeBinaryExpr$bx.removeAll(_removedtraces$MergeBinaryExpr$bxtraces$MergeBinaryExpr$bx_xx);
    }

  public static void setAlltraces$MergeBinaryExpr$bx(List binaryexpressions, List _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().settraces$MergeBinaryExpr$bx(binaryexpressionx, _val); } }

  public static void addAlltraces$MergeBinaryExpr$bx(List binaryexpressions, MergeBinaryExpr$trace _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().addtraces$MergeBinaryExpr$bx(binaryexpressionx,  _val); } }


  public static void removeAlltraces$MergeBinaryExpr$bx(List binaryexpressions,MergeBinaryExpr$trace _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().removetraces$MergeBinaryExpr$bx(binaryexpressionx, _val); } }


  public static void unionAlltraces$MergeBinaryExpr$bx(List binaryexpressions, List _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().uniontraces$MergeBinaryExpr$bx(binaryexpressionx, _val); } }


  public static void subtractAlltraces$MergeBinaryExpr$bx(List binaryexpressions,  List _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().subtracttraces$MergeBinaryExpr$bx(binaryexpressionx,  _val); } }


  public void settraces$MergeBinaryExpr$bx1(List traces$MergeBinaryExpr$bx1_xx) { traces$MergeBinaryExpr$bx1 = traces$MergeBinaryExpr$bx1_xx;
    }
 
  public void addtraces$MergeBinaryExpr$bx1(MergeBinaryExpr$trace traces$MergeBinaryExpr$bx1_xx) { if (traces$MergeBinaryExpr$bx1.contains(traces$MergeBinaryExpr$bx1_xx)) {} else { traces$MergeBinaryExpr$bx1.add(traces$MergeBinaryExpr$bx1_xx); }
    }
 
  public void removetraces$MergeBinaryExpr$bx1(MergeBinaryExpr$trace traces$MergeBinaryExpr$bx1_xx) { Vector _removedtraces$MergeBinaryExpr$bx1traces$MergeBinaryExpr$bx1_xx = new Vector();
  _removedtraces$MergeBinaryExpr$bx1traces$MergeBinaryExpr$bx1_xx.add(traces$MergeBinaryExpr$bx1_xx);
  traces$MergeBinaryExpr$bx1.removeAll(_removedtraces$MergeBinaryExpr$bx1traces$MergeBinaryExpr$bx1_xx);
    }

  public static void setAlltraces$MergeBinaryExpr$bx1(List binaryexpressions, List _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().settraces$MergeBinaryExpr$bx1(binaryexpressionx, _val); } }

  public static void addAlltraces$MergeBinaryExpr$bx1(List binaryexpressions, MergeBinaryExpr$trace _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().addtraces$MergeBinaryExpr$bx1(binaryexpressionx,  _val); } }


  public static void removeAlltraces$MergeBinaryExpr$bx1(List binaryexpressions,MergeBinaryExpr$trace _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().removetraces$MergeBinaryExpr$bx1(binaryexpressionx, _val); } }


  public static void unionAlltraces$MergeBinaryExpr$bx1(List binaryexpressions, List _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().uniontraces$MergeBinaryExpr$bx1(binaryexpressionx, _val); } }


  public static void subtractAlltraces$MergeBinaryExpr$bx1(List binaryexpressions,  List _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().subtracttraces$MergeBinaryExpr$bx1(binaryexpressionx,  _val); } }


  public void settraces$CopyBinaryExpr$bx(List traces$CopyBinaryExpr$bx_xx) { traces$CopyBinaryExpr$bx = traces$CopyBinaryExpr$bx_xx;
    }
 
  public void addtraces$CopyBinaryExpr$bx(CopyBinaryExpr$trace traces$CopyBinaryExpr$bx_xx) { if (traces$CopyBinaryExpr$bx.contains(traces$CopyBinaryExpr$bx_xx)) {} else { traces$CopyBinaryExpr$bx.add(traces$CopyBinaryExpr$bx_xx); }
    }
 
  public void removetraces$CopyBinaryExpr$bx(CopyBinaryExpr$trace traces$CopyBinaryExpr$bx_xx) { Vector _removedtraces$CopyBinaryExpr$bxtraces$CopyBinaryExpr$bx_xx = new Vector();
  _removedtraces$CopyBinaryExpr$bxtraces$CopyBinaryExpr$bx_xx.add(traces$CopyBinaryExpr$bx_xx);
  traces$CopyBinaryExpr$bx.removeAll(_removedtraces$CopyBinaryExpr$bxtraces$CopyBinaryExpr$bx_xx);
    }

  public static void setAlltraces$CopyBinaryExpr$bx(List binaryexpressions, List _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().settraces$CopyBinaryExpr$bx(binaryexpressionx, _val); } }

  public static void addAlltraces$CopyBinaryExpr$bx(List binaryexpressions, CopyBinaryExpr$trace _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().addtraces$CopyBinaryExpr$bx(binaryexpressionx,  _val); } }


  public static void removeAlltraces$CopyBinaryExpr$bx(List binaryexpressions,CopyBinaryExpr$trace _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().removetraces$CopyBinaryExpr$bx(binaryexpressionx, _val); } }


  public static void unionAlltraces$CopyBinaryExpr$bx(List binaryexpressions, List _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().uniontraces$CopyBinaryExpr$bx(binaryexpressionx, _val); } }


  public static void subtractAlltraces$CopyBinaryExpr$bx(List binaryexpressions,  List _val)
  { for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      Controller.inst().subtracttraces$CopyBinaryExpr$bx(binaryexpressionx,  _val); } }


    public String getoperator() { return operator; }

    public static List getAlloperator(List binaryexpressions)
  { List result = new Vector();
    for (int i = 0; i < binaryexpressions.size(); i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(i);
      if (result.contains(binaryexpressionx.getoperator())) { }
      else { result.add(binaryexpressionx.getoperator()); } }
    return result; }

    public static List getAllOrderedoperator(List binaryexpressions)
  { List result = new Vector();
    for (int i = 0; i < binaryexpressions.size(); i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(i);
      result.add(binaryexpressionx.getoperator()); } 
    return result; }

  public List gettraces$MergeBinaryExpr$bx() { return (Vector) ((Vector) traces$MergeBinaryExpr$bx).clone(); }

  public static List getAlltraces$MergeBinaryExpr$bx(List binaryexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      result = Set.union(result, binaryexpressionx.gettraces$MergeBinaryExpr$bx()); }
    return result; }

  public static List getAllOrderedtraces$MergeBinaryExpr$bx(List binaryexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      result = Set.union(result, binaryexpressionx.gettraces$MergeBinaryExpr$bx()); }
    return result; }

  public List gettraces$MergeBinaryExpr$bx1() { return (Vector) ((Vector) traces$MergeBinaryExpr$bx1).clone(); }

  public static List getAlltraces$MergeBinaryExpr$bx1(List binaryexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      result = Set.union(result, binaryexpressionx.gettraces$MergeBinaryExpr$bx1()); }
    return result; }

  public static List getAllOrderedtraces$MergeBinaryExpr$bx1(List binaryexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      result = Set.union(result, binaryexpressionx.gettraces$MergeBinaryExpr$bx1()); }
    return result; }

  public List gettraces$CopyBinaryExpr$bx() { return (Vector) ((Vector) traces$CopyBinaryExpr$bx).clone(); }

  public static List getAlltraces$CopyBinaryExpr$bx(List binaryexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      result = Set.union(result, binaryexpressionx.gettraces$CopyBinaryExpr$bx()); }
    return result; }

  public static List getAllOrderedtraces$CopyBinaryExpr$bx(List binaryexpressions)
  { List result = new Vector();
    for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(_i);
      result = Set.union(result, binaryexpressionx.gettraces$CopyBinaryExpr$bx()); }
    return result; }

    public void tau$cleanup2()
  {     List pre_traces$MergeBinaryExpr$bx16 = new Vector();
    pre_traces$MergeBinaryExpr$bx16.addAll(traces$MergeBinaryExpr$bx);
    List pre_traces$CopyBinaryExpr$bx17 = new Vector();
    pre_traces$CopyBinaryExpr$bx17.addAll(traces$CopyBinaryExpr$bx);
  if ((pre_traces$MergeBinaryExpr$bx16.size() == 0) && (pre_traces$CopyBinaryExpr$bx17.size() == 0)) 
  { Controller.inst().killBinaryExpression(this);}
  }


}


class Edge
  implements SystemTypes
{
  private String label = ""; // internal
  private Expression target;
  private Expression source;

  public Edge(Expression target,Expression source)
  {
    this.label = "";
    this.target = target;
    this.source = source;

  }

  public Edge() { }



  public String toString()
  { String _res_ = "(Edge) ";
    _res_ = _res_ + label;
    return _res_;
  }

  public static Edge parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    Edge edgex = new Edge();
    edgex.label = (String) _line1vals.get(0);
    return edgex;
  }


  public void writeCSV(PrintWriter _out)
  { Edge edgex = this;
    _out.print("" + edgex.label);
    _out.println();
  }


  public void setlabel(String label_x) { label = label_x;  }


    public static void setAlllabel(List edges,String val)
  { for (int i = 0; i < edges.size(); i++)
    { Edge edgex = (Edge) edges.get(i);
      Controller.inst().setlabel(edgex,val); } }


  public void settarget(Expression target_xx) { target = target_xx;
  }

  public static void setAlltarget(List edges, Expression _val)
  { for (int _i = 0; _i < edges.size(); _i++)
    { Edge edgex = (Edge) edges.get(_i);
      Controller.inst().settarget(edgex, _val); } }

  public void setsource(Expression source_xx) { source = source_xx;
  }

  public static void setAllsource(List edges, Expression _val)
  { for (int _i = 0; _i < edges.size(); _i++)
    { Edge edgex = (Edge) edges.get(_i);
      Controller.inst().setsource(edgex, _val); } }

    public String getlabel() { return label; }

    public static List getAlllabel(List edges)
  { List result = new Vector();
    for (int i = 0; i < edges.size(); i++)
    { Edge edgex = (Edge) edges.get(i);
      if (result.contains(edgex.getlabel())) { }
      else { result.add(edgex.getlabel()); } }
    return result; }

    public static List getAllOrderedlabel(List edges)
  { List result = new Vector();
    for (int i = 0; i < edges.size(); i++)
    { Edge edgex = (Edge) edges.get(i);
      result.add(edgex.getlabel()); } 
    return result; }

  public Expression gettarget() { return target; }

  public static List getAlltarget(List edges)
  { List result = new Vector();
    for (int _i = 0; _i < edges.size(); _i++)
    { Edge edgex = (Edge) edges.get(_i);
      if (result.contains(edgex.gettarget())) {}
      else { result.add(edgex.gettarget()); }
 }
    return result; }

  public static List getAllOrderedtarget(List edges)
  { List result = new Vector();
    for (int _i = 0; _i < edges.size(); _i++)
    { Edge edgex = (Edge) edges.get(_i);
      if (result.contains(edgex.gettarget())) {}
      else { result.add(edgex.gettarget()); }
 }
    return result; }

  public Expression getsource() { return source; }

  public static List getAllsource(List edges)
  { List result = new Vector();
    for (int _i = 0; _i < edges.size(); _i++)
    { Edge edgex = (Edge) edges.get(_i);
      if (result.contains(edgex.getsource())) {}
      else { result.add(edgex.getsource()); }
 }
    return result; }

  public static List getAllOrderedsource(List edges)
  { List result = new Vector();
    for (int _i = 0; _i < edges.size(); _i++)
    { Edge edgex = (Edge) edges.get(_i);
      if (result.contains(edgex.getsource())) {}
      else { result.add(edgex.getsource()); }
 }
    return result; }


}


class MergeBasicExpr$trace
  implements SystemTypes
{
  private BasicExpression be;
  private BasicExpression be1;

  public MergeBasicExpr$trace(BasicExpression be,BasicExpression be1)
  {
    this.be = be;
    this.be1 = be1;

  }

  public MergeBasicExpr$trace() { }



  public String toString()
  { String _res_ = "(MergeBasicExpr$trace) ";
    return _res_;
  }

  public static MergeBasicExpr$trace parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    MergeBasicExpr$trace mergebasicexpr$tracex = new MergeBasicExpr$trace();
    return mergebasicexpr$tracex;
  }


  public void writeCSV(PrintWriter _out)
  { MergeBasicExpr$trace mergebasicexpr$tracex = this;
    _out.println();
  }


  public void setbe(BasicExpression be_xx) { be = be_xx;
  }

  public static void setAllbe(List mergebasicexpr$traces, BasicExpression _val)
  { for (int _i = 0; _i < mergebasicexpr$traces.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracex = (MergeBasicExpr$trace) mergebasicexpr$traces.get(_i);
      Controller.inst().setbe(mergebasicexpr$tracex, _val); } }

  public void setbe1(BasicExpression be1_xx) { be1 = be1_xx;
  }

  public static void setAllbe1(List mergebasicexpr$traces, BasicExpression _val)
  { for (int _i = 0; _i < mergebasicexpr$traces.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracex = (MergeBasicExpr$trace) mergebasicexpr$traces.get(_i);
      Controller.inst().setbe1(mergebasicexpr$tracex, _val); } }

  public BasicExpression getbe() { return be; }

  public static List getAllbe(List mergebasicexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < mergebasicexpr$traces.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracex = (MergeBasicExpr$trace) mergebasicexpr$traces.get(_i);
      if (result.contains(mergebasicexpr$tracex.getbe())) {}
      else { result.add(mergebasicexpr$tracex.getbe()); }
 }
    return result; }

  public static List getAllOrderedbe(List mergebasicexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < mergebasicexpr$traces.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracex = (MergeBasicExpr$trace) mergebasicexpr$traces.get(_i);
      if (result.contains(mergebasicexpr$tracex.getbe())) {}
      else { result.add(mergebasicexpr$tracex.getbe()); }
 }
    return result; }

  public BasicExpression getbe1() { return be1; }

  public static List getAllbe1(List mergebasicexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < mergebasicexpr$traces.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracex = (MergeBasicExpr$trace) mergebasicexpr$traces.get(_i);
      if (result.contains(mergebasicexpr$tracex.getbe1())) {}
      else { result.add(mergebasicexpr$tracex.getbe1()); }
 }
    return result; }

  public static List getAllOrderedbe1(List mergebasicexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < mergebasicexpr$traces.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracex = (MergeBasicExpr$trace) mergebasicexpr$traces.get(_i);
      if (result.contains(mergebasicexpr$tracex.getbe1())) {}
      else { result.add(mergebasicexpr$tracex.getbe1()); }
 }
    return result; }

    public void tau$pres1()
  {   //  if ((be instanceof BasicExpression@pre) && (be1 instanceof BasicExpression@pre) && !(be.equals(be1)) && be.getname().equals(be1.getname()) && be.getvalue().equals(be1.getvalue()) && be.getoutgoing().size() > 0)) { return; } 
  Controller.inst().killMergeBasicExpr$trace(this);
  }

    public boolean tau$pres1test()
  {  boolean result;
MergeBasicExpr$trace mergebasicexpr$tracex = this;
      List pre_BasicExpression18 = new Vector();
    pre_BasicExpression18.addAll(Controller.inst().basicexpressions);
    String pre_name19 = be.getname();
    String pre_name20 = be1.getname();
    String pre_value21 = be.getvalue();
    String pre_value22 = be1.getvalue();
    List pre_outgoing23 = new Vector();
    pre_outgoing23.addAll(be.getoutgoing());
   if (!(pre_BasicExpression18.contains(mergebasicexpr$tracex.getbe()) && pre_BasicExpression18.contains(mergebasicexpr$tracex.getbe1()) && !(mergebasicexpr$tracex.getbe().equals(mergebasicexpr$tracex.getbe1())) && pre_name19.equals(pre_name20) && pre_value21.equals(pre_value22) && pre_outgoing23.size() > 0)) {   return true; }

    return false;

  }


    public static boolean tau$pres1search()
  {  boolean result;
  List _range25 = new Vector();
  _range25.addAll(Controller.inst().mergebasicexpr$traces);
  for (int _i24 = 0; _i24 < _range25.size(); _i24++)
  { MergeBasicExpr$trace mergebasicexpr$tracex = (MergeBasicExpr$trace) _range25.get(_i24);
       if (mergebasicexpr$tracex.tau$pres1test()) {    Controller.inst().tau$pres1(mergebasicexpr$tracex);
    return true;
 }

  }
    return false;

  }


    public void tau$pres2()
  {     String pre_name26 = be.getname();
    String pre_name27 = be1.getname();
    String pre_value28 = be.getvalue();
    String pre_value29 = be1.getvalue();
    List pre_outgoing30 = new Vector();
    pre_outgoing30.addAll(be.getoutgoing());
    List pre_outgoing31 = new Vector();
    pre_outgoing31.addAll(be1.getoutgoing());
  if (!(this.getbe().equals(this.getbe1())) && pre_name26.equals(pre_name27) && pre_value28.equals(pre_value29) && pre_outgoing30.size() > 0) 
  {     List _edge_list32 = new Vector();
    _edge_list32.addAll(pre_outgoing31);
    for (int _ind33 = 0; _ind33 < _edge_list32.size(); _ind33++)
    { Edge e = (Edge) _edge_list32.get(_ind33);
      Controller.inst().addoutgoing(this.getbe(),e);
    }
}
  }


}


class CopyBasicExpr$trace
  implements SystemTypes
{
  private BasicExpression be;

  public CopyBasicExpr$trace(BasicExpression be)
  {
    this.be = be;

  }

  public CopyBasicExpr$trace() { }



  public String toString()
  { String _res_ = "(CopyBasicExpr$trace) ";
    return _res_;
  }

  public static CopyBasicExpr$trace parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    CopyBasicExpr$trace copybasicexpr$tracex = new CopyBasicExpr$trace();
    return copybasicexpr$tracex;
  }


  public void writeCSV(PrintWriter _out)
  { CopyBasicExpr$trace copybasicexpr$tracex = this;
    _out.println();
  }


  public void setbe(BasicExpression be_xx) { be = be_xx;
  }

  public static void setAllbe(List copybasicexpr$traces, BasicExpression _val)
  { for (int _i = 0; _i < copybasicexpr$traces.size(); _i++)
    { CopyBasicExpr$trace copybasicexpr$tracex = (CopyBasicExpr$trace) copybasicexpr$traces.get(_i);
      Controller.inst().setbe(copybasicexpr$tracex, _val); } }

  public BasicExpression getbe() { return be; }

  public static List getAllbe(List copybasicexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < copybasicexpr$traces.size(); _i++)
    { CopyBasicExpr$trace copybasicexpr$tracex = (CopyBasicExpr$trace) copybasicexpr$traces.get(_i);
      if (result.contains(copybasicexpr$tracex.getbe())) {}
      else { result.add(copybasicexpr$tracex.getbe()); }
 }
    return result; }

  public static List getAllOrderedbe(List copybasicexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < copybasicexpr$traces.size(); _i++)
    { CopyBasicExpr$trace copybasicexpr$tracex = (CopyBasicExpr$trace) copybasicexpr$traces.get(_i);
      if (result.contains(copybasicexpr$tracex.getbe())) {}
      else { result.add(copybasicexpr$tracex.getbe()); }
 }
    return result; }

    public void tau$pres3()
  {     List pre_BasicExpression34 = new Vector();
    pre_BasicExpression34.addAll(Controller.inst().basicexpressions);
    List pre_outgoing35 = new Vector();
    pre_outgoing35.addAll(be.getoutgoing());
  if (!(pre_BasicExpression34.contains(this.getbe()) && pre_outgoing35.size() > 0)) 
  { Controller.inst().killCopyBasicExpr$trace(this);}
  }


}


class MergeBinaryExpr$trace
  implements SystemTypes
{
  private BinaryExpression bx;
  private BinaryExpression bx1;

  public MergeBinaryExpr$trace(BinaryExpression bx,BinaryExpression bx1)
  {
    this.bx = bx;
    this.bx1 = bx1;

  }

  public MergeBinaryExpr$trace() { }



  public String toString()
  { String _res_ = "(MergeBinaryExpr$trace) ";
    return _res_;
  }

  public static MergeBinaryExpr$trace parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    MergeBinaryExpr$trace mergebinaryexpr$tracex = new MergeBinaryExpr$trace();
    return mergebinaryexpr$tracex;
  }


  public void writeCSV(PrintWriter _out)
  { MergeBinaryExpr$trace mergebinaryexpr$tracex = this;
    _out.println();
  }


  public void setbx(BinaryExpression bx_xx) { bx = bx_xx;
  }

  public static void setAllbx(List mergebinaryexpr$traces, BinaryExpression _val)
  { for (int _i = 0; _i < mergebinaryexpr$traces.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracex = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i);
      Controller.inst().setbx(mergebinaryexpr$tracex, _val); } }

  public void setbx1(BinaryExpression bx1_xx) { bx1 = bx1_xx;
  }

  public static void setAllbx1(List mergebinaryexpr$traces, BinaryExpression _val)
  { for (int _i = 0; _i < mergebinaryexpr$traces.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracex = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i);
      Controller.inst().setbx1(mergebinaryexpr$tracex, _val); } }

  public BinaryExpression getbx() { return bx; }

  public static List getAllbx(List mergebinaryexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < mergebinaryexpr$traces.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracex = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i);
      if (result.contains(mergebinaryexpr$tracex.getbx())) {}
      else { result.add(mergebinaryexpr$tracex.getbx()); }
 }
    return result; }

  public static List getAllOrderedbx(List mergebinaryexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < mergebinaryexpr$traces.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracex = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i);
      if (result.contains(mergebinaryexpr$tracex.getbx())) {}
      else { result.add(mergebinaryexpr$tracex.getbx()); }
 }
    return result; }

  public BinaryExpression getbx1() { return bx1; }

  public static List getAllbx1(List mergebinaryexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < mergebinaryexpr$traces.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracex = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i);
      if (result.contains(mergebinaryexpr$tracex.getbx1())) {}
      else { result.add(mergebinaryexpr$tracex.getbx1()); }
 }
    return result; }

  public static List getAllOrderedbx1(List mergebinaryexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < mergebinaryexpr$traces.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracex = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i);
      if (result.contains(mergebinaryexpr$tracex.getbx1())) {}
      else { result.add(mergebinaryexpr$tracex.getbx1()); }
 }
    return result; }

    public void tau$pres4()
  {   //  if ((bx instanceof BinaryExpression@pre) && (bx1 instanceof BinaryExpression@pre) && !(bx.equals(bx1)) && bx.getoperator().equals(bx1.getoperator()) && Set.equals(Edge.getAllsource(bx.getincoming()),Edge.getAllsource(bx1.getincoming())) && bx.getincoming().size() > 0)) { return; } 
  Controller.inst().killMergeBinaryExpr$trace(this);
  }

    public boolean tau$pres4test()
  {  boolean result;
MergeBinaryExpr$trace mergebinaryexpr$tracex = this;
      List pre_BinaryExpression36 = new Vector();
    pre_BinaryExpression36.addAll(Controller.inst().binaryexpressions);
    String pre_operator37 = bx.getoperator();
    String pre_operator38 = bx1.getoperator();
    List pre_source39 = new Vector();
    pre_source39.addAll(Edge.getAllsource(bx.getincoming()));
    List pre_incoming40 = new Vector();
    pre_incoming40.addAll(bx.getincoming());
    List pre_source41 = new Vector();
    pre_source41.addAll(Edge.getAllsource(bx1.getincoming()));
    List pre_incoming42 = new Vector();
    pre_incoming42.addAll(bx1.getincoming());
   if (!(pre_BinaryExpression36.contains(mergebinaryexpr$tracex.getbx()) && pre_BinaryExpression36.contains(mergebinaryexpr$tracex.getbx1()) && !(mergebinaryexpr$tracex.getbx().equals(mergebinaryexpr$tracex.getbx1())) && pre_operator37.equals(pre_operator38) && Set.equals(pre_source39,pre_source41) && pre_incoming40.size() > 0)) {   return true; }

    return false;

  }


    public static boolean tau$pres4search()
  {  boolean result;
  List _range44 = new Vector();
  _range44.addAll(Controller.inst().mergebinaryexpr$traces);
  for (int _i43 = 0; _i43 < _range44.size(); _i43++)
  { MergeBinaryExpr$trace mergebinaryexpr$tracex = (MergeBinaryExpr$trace) _range44.get(_i43);
       if (mergebinaryexpr$tracex.tau$pres4test()) {    Controller.inst().tau$pres4(mergebinaryexpr$tracex);
    return true;
 }

  }
    return false;

  }


    public void tau$pres5()
  {     String pre_operator45 = bx.getoperator();
    String pre_operator46 = bx1.getoperator();
    List pre_source47 = new Vector();
    pre_source47.addAll(Edge.getAllsource(bx.getincoming()));
    List pre_incoming48 = new Vector();
    pre_incoming48.addAll(bx.getincoming());
    List pre_source49 = new Vector();
    pre_source49.addAll(Edge.getAllsource(bx1.getincoming()));
    List pre_incoming50 = new Vector();
    pre_incoming50.addAll(bx1.getincoming());
    List pre_outgoing51 = new Vector();
    pre_outgoing51.addAll(bx1.getoutgoing());
  if (!(this.getbx().equals(this.getbx1())) && pre_operator45.equals(pre_operator46) && Set.equals(pre_source47,pre_source49) && pre_incoming48.size() > 0) 
  {     List _edge_list52 = new Vector();
    _edge_list52.addAll(pre_incoming50);
    for (int _ind53 = 0; _ind53 < _edge_list52.size(); _ind53++)
    { Edge e = (Edge) _edge_list52.get(_ind53);
      Controller.inst().addincoming(this.getbx(),e);
    }

        List _edge_list54 = new Vector();
    _edge_list54.addAll(pre_outgoing51);
    for (int _ind55 = 0; _ind55 < _edge_list54.size(); _ind55++)
    { Edge f = (Edge) _edge_list54.get(_ind55);
      Controller.inst().addoutgoing(this.getbx(),f);
    }
}
  }


}


class CopyBinaryExpr$trace
  implements SystemTypes
{
  private BinaryExpression bx;

  public CopyBinaryExpr$trace(BinaryExpression bx)
  {
    this.bx = bx;

  }

  public CopyBinaryExpr$trace() { }



  public String toString()
  { String _res_ = "(CopyBinaryExpr$trace) ";
    return _res_;
  }

  public static CopyBinaryExpr$trace parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    CopyBinaryExpr$trace copybinaryexpr$tracex = new CopyBinaryExpr$trace();
    return copybinaryexpr$tracex;
  }


  public void writeCSV(PrintWriter _out)
  { CopyBinaryExpr$trace copybinaryexpr$tracex = this;
    _out.println();
  }


  public void setbx(BinaryExpression bx_xx) { bx = bx_xx;
  }

  public static void setAllbx(List copybinaryexpr$traces, BinaryExpression _val)
  { for (int _i = 0; _i < copybinaryexpr$traces.size(); _i++)
    { CopyBinaryExpr$trace copybinaryexpr$tracex = (CopyBinaryExpr$trace) copybinaryexpr$traces.get(_i);
      Controller.inst().setbx(copybinaryexpr$tracex, _val); } }

  public BinaryExpression getbx() { return bx; }

  public static List getAllbx(List copybinaryexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < copybinaryexpr$traces.size(); _i++)
    { CopyBinaryExpr$trace copybinaryexpr$tracex = (CopyBinaryExpr$trace) copybinaryexpr$traces.get(_i);
      if (result.contains(copybinaryexpr$tracex.getbx())) {}
      else { result.add(copybinaryexpr$tracex.getbx()); }
 }
    return result; }

  public static List getAllOrderedbx(List copybinaryexpr$traces)
  { List result = new Vector();
    for (int _i = 0; _i < copybinaryexpr$traces.size(); _i++)
    { CopyBinaryExpr$trace copybinaryexpr$tracex = (CopyBinaryExpr$trace) copybinaryexpr$traces.get(_i);
      if (result.contains(copybinaryexpr$tracex.getbx())) {}
      else { result.add(copybinaryexpr$tracex.getbx()); }
 }
    return result; }

    public void tau$pres6()
  {     List pre_BinaryExpression56 = new Vector();
    pre_BinaryExpression56.addAll(Controller.inst().binaryexpressions);
    List pre_incoming57 = new Vector();
    pre_incoming57.addAll(bx.getincoming());
  if (!(pre_BinaryExpression56.contains(this.getbx()) && pre_incoming57.size() > 0)) 
  { Controller.inst().killCopyBinaryExpr$trace(this);}
  }


}


class Tau$Pres
  implements SystemTypes
{

  public Tau$Pres()
  {

  }



  public String toString()
  { String _res_ = "(Tau$Pres) ";
    return _res_;
  }

  public static Tau$Pres parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    Tau$Pres tau$presx = new Tau$Pres();
    return tau$presx;
  }


  public void writeCSV(PrintWriter _out)
  { Tau$Pres tau$presx = this;
    _out.println();
  }


  


}


class Tau$Con
  implements SystemTypes
{

  public Tau$Con()
  {

  }



  public String toString()
  { String _res_ = "(Tau$Con) ";
    return _res_;
  }

  public static Tau$Con parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    Tau$Con tau$conx = new Tau$Con();
    return tau$conx;
  }


  public void writeCSV(PrintWriter _out)
  { Tau$Con tau$conx = this;
    _out.println();
  }


  


}


class Tau$Cleanup
  implements SystemTypes
{

  public Tau$Cleanup()
  {

  }



  public String toString()
  { String _res_ = "(Tau$Cleanup) ";
    return _res_;
  }

  public static Tau$Cleanup parseCSV(String _line)
  { if (_line == null) { return null; }
    Vector _line1vals = Set.tokeniseCSV(_line);
    Tau$Cleanup tau$cleanupx = new Tau$Cleanup();
    return tau$cleanupx;
  }


  public void writeCSV(PrintWriter _out)
  { Tau$Cleanup tau$cleanupx = this;
    _out.println();
  }


  


}



public class Controller implements SystemTypes, ControllerInterface
{
  Vector expressions = new Vector();
  Vector basicexpressions = new Vector();
  Vector binaryexpressions = new Vector();
  Vector edges = new Vector();
  Vector mergebasicexpr$traces = new Vector();
  Vector copybasicexpr$traces = new Vector();
  Vector mergebinaryexpr$traces = new Vector();
  Vector copybinaryexpr$traces = new Vector();
  Vector tau$press = new Vector();
  Vector tau$cons = new Vector();
  Vector tau$cleanups = new Vector();
  private static Controller uniqueInstance; 


  private Controller() { } 


  public static Controller inst() 
    { if (uniqueInstance == null) 
    { uniqueInstance = new Controller(); }
    return uniqueInstance; } 


  public static void loadModel(String file)
  {
    try
    { BufferedReader br = null;
      File f = new File(file);
      try 
      { br = new BufferedReader(new FileReader(f)); }
      catch (Exception ex) 
      { System.err.println("No file: " + file); return; }
      Class cont = Class.forName("Controller");
      java.util.Map objectmap = new java.util.HashMap();
      while (true)
      { String line1;
        try { line1 = br.readLine(); }
        catch (Exception e)
        { return; }
        if (line1 == null)
        { return; }
        line1 = line1.trim();

        if (line1.length() == 0) { continue; }
        if (line1.startsWith("//")) { continue; }
        String left;
        String op;
        String right;
        if (line1.charAt(line1.length() - 1) == '"')
        { int eqind = line1.indexOf("="); 
          if (eqind == -1) { continue; }
          else 
          { left = line1.substring(0,eqind-1).trim();
            op = "="; 
            right = line1.substring(eqind+1,line1.length()).trim();
          }
        }
        else
        { StringTokenizer st1 = new StringTokenizer(line1);
          Vector vals1 = new Vector();
          while (st1.hasMoreTokens())
          { String val1 = st1.nextToken();
            vals1.add(val1);
          }
          if (vals1.size() < 3)
          { continue; }
          left = (String) vals1.get(0);
          op = (String) vals1.get(1);
          right = (String) vals1.get(2);
        }
        if (":".equals(op))
        { int i2 = right.indexOf(".");
          if (i2 == -1)
          { Class cl;
            try { cl = Class.forName("" + right); }
            catch (Exception _x) { System.err.println("No entity: " + right); continue; }
            Object xinst = cl.newInstance();
            objectmap.put(left,xinst);
            Class[] cargs = new Class[] { cl };
            Method addC = null;
            try { addC = cont.getMethod("add" + right,cargs); }
            catch (Exception _xx) { System.err.println("No entity: " + right); continue; }
            if (addC == null) { continue; }
            Object[] args = new Object[] { xinst };
            addC.invoke(Controller.inst(),args);
          }
          else
          { String obj = right.substring(0,i2);
            String role = right.substring(i2+1,right.length());
            Object objinst = objectmap.get(obj); 
            if (objinst == null) 
            { continue; }
            Object val = objectmap.get(left);
            if (val == null) 
            { continue; }
            Class objC = objinst.getClass();
            Class typeclass = val.getClass(); 
            Object[] args = new Object[] { val }; 
            Class[] settypes = new Class[] { typeclass };
            Method addrole = Controller.findMethod(objC,"add" + role);
            if (addrole != null) 
            { addrole.invoke(objinst, args); }
            else { System.err.println("Error: cannot add to " + role); }
          }
        }
        else if ("=".equals(op))
        { int i1 = left.indexOf(".");
          if (i1 == -1) 
          { continue; }
          String obj = left.substring(0,i1);
          String att = left.substring(i1+1,left.length());
          Object objinst = objectmap.get(obj); 
          if (objinst == null) 
          { System.err.println("No object: " + obj); continue; }
          Class objC = objinst.getClass();
          Class typeclass; 
          Object val; 
          if (right.charAt(0) == '"' &&
              right.charAt(right.length() - 1) == '"')
          { typeclass = String.class;
            val = right.substring(1,right.length() - 1);
          } 
          else if ("true".equals(right) || "false".equals(right))
          { typeclass = boolean.class;
            if ("true".equals(right))
            { val = new Boolean(true); }
            else
            { val = new Boolean(false); }
          }
          else 
          { val = objectmap.get(right);
            if (val != null)
            { typeclass = val.getClass(); }
            else 
            { int i;
              long l; 
              double d;
              try 
              { i = Integer.parseInt(right);
                typeclass = int.class;
                val = new Integer(i); 
              }
              catch (Exception ee)
              { try 
                { l = Long.parseLong(right);
                  typeclass = long.class;
                  val = new Long(l); 
                }
                catch (Exception eee)
                { try
                  { d = Double.parseDouble(right);
                    typeclass = double.class;
                    val = new Double(d);
                  }
                  catch (Exception ff)
                  { continue; }
                }
              }
            }
          }
          Object[] args = new Object[] { val }; 
          Class[] settypes = new Class[] { typeclass };
          Method setatt = Controller.findMethod(objC,"set" + att);
          if (setatt != null) 
          { setatt.invoke(objinst, args); }
          else { System.err.println("No attribute: " + objC.getName() + "::" + att); }
        }
      }
    } catch (Exception e) { }
  }

  public static Method findMethod(Class c, String name)
  { Method[] mets = c.getMethods(); 
    for (int i = 0; i < mets.length; i++)
    { Method m = mets[i];
      if (m.getName().equals(name))
      { return m; }
    } 
    return null;
  }


  public static void loadCSVModel()
  { boolean __eof = false;
    String __s = "";
    Controller __cont = Controller.inst();
    BufferedReader __br = null;
    try
    { File _basicexpression = new File("BasicExpression.csv");
      __br = new BufferedReader(new FileReader(_basicexpression));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { BasicExpression basicexpressionx = BasicExpression.parseCSV(__s.trim());
          if (basicexpressionx != null)
          { __cont.addBasicExpression(basicexpressionx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _binaryexpression = new File("BinaryExpression.csv");
      __br = new BufferedReader(new FileReader(_binaryexpression));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { BinaryExpression binaryexpressionx = BinaryExpression.parseCSV(__s.trim());
          if (binaryexpressionx != null)
          { __cont.addBinaryExpression(binaryexpressionx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _edge = new File("Edge.csv");
      __br = new BufferedReader(new FileReader(_edge));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { Edge edgex = Edge.parseCSV(__s.trim());
          if (edgex != null)
          { __cont.addEdge(edgex); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _mergebasicexpr$trace = new File("MergeBasicExpr$trace.csv");
      __br = new BufferedReader(new FileReader(_mergebasicexpr$trace));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { MergeBasicExpr$trace mergebasicexpr$tracex = MergeBasicExpr$trace.parseCSV(__s.trim());
          if (mergebasicexpr$tracex != null)
          { __cont.addMergeBasicExpr$trace(mergebasicexpr$tracex); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _copybasicexpr$trace = new File("CopyBasicExpr$trace.csv");
      __br = new BufferedReader(new FileReader(_copybasicexpr$trace));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { CopyBasicExpr$trace copybasicexpr$tracex = CopyBasicExpr$trace.parseCSV(__s.trim());
          if (copybasicexpr$tracex != null)
          { __cont.addCopyBasicExpr$trace(copybasicexpr$tracex); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _mergebinaryexpr$trace = new File("MergeBinaryExpr$trace.csv");
      __br = new BufferedReader(new FileReader(_mergebinaryexpr$trace));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { MergeBinaryExpr$trace mergebinaryexpr$tracex = MergeBinaryExpr$trace.parseCSV(__s.trim());
          if (mergebinaryexpr$tracex != null)
          { __cont.addMergeBinaryExpr$trace(mergebinaryexpr$tracex); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _copybinaryexpr$trace = new File("CopyBinaryExpr$trace.csv");
      __br = new BufferedReader(new FileReader(_copybinaryexpr$trace));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { CopyBinaryExpr$trace copybinaryexpr$tracex = CopyBinaryExpr$trace.parseCSV(__s.trim());
          if (copybinaryexpr$tracex != null)
          { __cont.addCopyBinaryExpr$trace(copybinaryexpr$tracex); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _tau$pres = new File("Tau$Pres.csv");
      __br = new BufferedReader(new FileReader(_tau$pres));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { Tau$Pres tau$presx = Tau$Pres.parseCSV(__s.trim());
          if (tau$presx != null)
          { __cont.addTau$Pres(tau$presx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _tau$con = new File("Tau$Con.csv");
      __br = new BufferedReader(new FileReader(_tau$con));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { Tau$Con tau$conx = Tau$Con.parseCSV(__s.trim());
          if (tau$conx != null)
          { __cont.addTau$Con(tau$conx); }
        }
      }
    }
    catch(Exception __e) { }
    try
    { File _tau$cleanup = new File("Tau$Cleanup.csv");
      __br = new BufferedReader(new FileReader(_tau$cleanup));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { Tau$Cleanup tau$cleanupx = Tau$Cleanup.parseCSV(__s.trim());
          if (tau$cleanupx != null)
          { __cont.addTau$Cleanup(tau$cleanupx); }
        }
      }
    }
    catch(Exception __e) { }
  }


  public void checkCompleteness()
  {   for (int _i = 0; _i < edges.size(); _i++)
  { Edge incoming_edgex1 = (Edge) edges.get(_i);
    for (int _j = 0; _j < expressions.size(); _j++)
    { Expression target_expressionx2 = (Expression) expressions.get(_j);
      if (incoming_edgex1.gettarget() == target_expressionx2)
      { if (target_expressionx2.getincoming().contains(incoming_edgex1)) { }
        else { target_expressionx2.addincoming(incoming_edgex1); }
      }
      else if (target_expressionx2.getincoming().contains(incoming_edgex1))
      { incoming_edgex1.settarget(target_expressionx2); } 
    }
  }
  for (int _i = 0; _i < edges.size(); _i++)
  { Edge outgoing_edgex1 = (Edge) edges.get(_i);
    for (int _j = 0; _j < expressions.size(); _j++)
    { Expression source_expressionx2 = (Expression) expressions.get(_j);
      if (outgoing_edgex1.getsource() == source_expressionx2)
      { if (source_expressionx2.getoutgoing().contains(outgoing_edgex1)) { }
        else { source_expressionx2.addoutgoing(outgoing_edgex1); }
      }
      else if (source_expressionx2.getoutgoing().contains(outgoing_edgex1))
      { outgoing_edgex1.setsource(source_expressionx2); } 
    }
  }
  for (int _i = 0; _i < mergebasicexpr$traces.size(); _i++)
  { MergeBasicExpr$trace traces$MergeBasicExpr$be_mergebasicexpr$tracex1 = (MergeBasicExpr$trace) mergebasicexpr$traces.get(_i);
    for (int _j = 0; _j < basicexpressions.size(); _j++)
    { BasicExpression be_basicexpressionx2 = (BasicExpression) basicexpressions.get(_j);
      if (traces$MergeBasicExpr$be_mergebasicexpr$tracex1.getbe() == be_basicexpressionx2)
      { if (be_basicexpressionx2.gettraces$MergeBasicExpr$be().contains(traces$MergeBasicExpr$be_mergebasicexpr$tracex1)) { }
        else { be_basicexpressionx2.addtraces$MergeBasicExpr$be(traces$MergeBasicExpr$be_mergebasicexpr$tracex1); }
      }
      else if (be_basicexpressionx2.gettraces$MergeBasicExpr$be().contains(traces$MergeBasicExpr$be_mergebasicexpr$tracex1))
      { traces$MergeBasicExpr$be_mergebasicexpr$tracex1.setbe(be_basicexpressionx2); } 
    }
  }
  for (int _i = 0; _i < mergebasicexpr$traces.size(); _i++)
  { MergeBasicExpr$trace traces$MergeBasicExpr$be1_mergebasicexpr$tracex1 = (MergeBasicExpr$trace) mergebasicexpr$traces.get(_i);
    for (int _j = 0; _j < basicexpressions.size(); _j++)
    { BasicExpression be1_basicexpressionx2 = (BasicExpression) basicexpressions.get(_j);
      if (traces$MergeBasicExpr$be1_mergebasicexpr$tracex1.getbe1() == be1_basicexpressionx2)
      { if (be1_basicexpressionx2.gettraces$MergeBasicExpr$be1().contains(traces$MergeBasicExpr$be1_mergebasicexpr$tracex1)) { }
        else { be1_basicexpressionx2.addtraces$MergeBasicExpr$be1(traces$MergeBasicExpr$be1_mergebasicexpr$tracex1); }
      }
      else if (be1_basicexpressionx2.gettraces$MergeBasicExpr$be1().contains(traces$MergeBasicExpr$be1_mergebasicexpr$tracex1))
      { traces$MergeBasicExpr$be1_mergebasicexpr$tracex1.setbe1(be1_basicexpressionx2); } 
    }
  }
  for (int _i = 0; _i < copybasicexpr$traces.size(); _i++)
  { CopyBasicExpr$trace traces$CopyBasicExpr$be_copybasicexpr$tracex1 = (CopyBasicExpr$trace) copybasicexpr$traces.get(_i);
    for (int _j = 0; _j < basicexpressions.size(); _j++)
    { BasicExpression be_basicexpressionx2 = (BasicExpression) basicexpressions.get(_j);
      if (traces$CopyBasicExpr$be_copybasicexpr$tracex1.getbe() == be_basicexpressionx2)
      { if (be_basicexpressionx2.gettraces$CopyBasicExpr$be().contains(traces$CopyBasicExpr$be_copybasicexpr$tracex1)) { }
        else { be_basicexpressionx2.addtraces$CopyBasicExpr$be(traces$CopyBasicExpr$be_copybasicexpr$tracex1); }
      }
      else if (be_basicexpressionx2.gettraces$CopyBasicExpr$be().contains(traces$CopyBasicExpr$be_copybasicexpr$tracex1))
      { traces$CopyBasicExpr$be_copybasicexpr$tracex1.setbe(be_basicexpressionx2); } 
    }
  }
  for (int _i = 0; _i < mergebinaryexpr$traces.size(); _i++)
  { MergeBinaryExpr$trace traces$MergeBinaryExpr$bx_mergebinaryexpr$tracex1 = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i);
    for (int _j = 0; _j < binaryexpressions.size(); _j++)
    { BinaryExpression bx_binaryexpressionx2 = (BinaryExpression) binaryexpressions.get(_j);
      if (traces$MergeBinaryExpr$bx_mergebinaryexpr$tracex1.getbx() == bx_binaryexpressionx2)
      { if (bx_binaryexpressionx2.gettraces$MergeBinaryExpr$bx().contains(traces$MergeBinaryExpr$bx_mergebinaryexpr$tracex1)) { }
        else { bx_binaryexpressionx2.addtraces$MergeBinaryExpr$bx(traces$MergeBinaryExpr$bx_mergebinaryexpr$tracex1); }
      }
      else if (bx_binaryexpressionx2.gettraces$MergeBinaryExpr$bx().contains(traces$MergeBinaryExpr$bx_mergebinaryexpr$tracex1))
      { traces$MergeBinaryExpr$bx_mergebinaryexpr$tracex1.setbx(bx_binaryexpressionx2); } 
    }
  }
  for (int _i = 0; _i < mergebinaryexpr$traces.size(); _i++)
  { MergeBinaryExpr$trace traces$MergeBinaryExpr$bx1_mergebinaryexpr$tracex1 = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i);
    for (int _j = 0; _j < binaryexpressions.size(); _j++)
    { BinaryExpression bx1_binaryexpressionx2 = (BinaryExpression) binaryexpressions.get(_j);
      if (traces$MergeBinaryExpr$bx1_mergebinaryexpr$tracex1.getbx1() == bx1_binaryexpressionx2)
      { if (bx1_binaryexpressionx2.gettraces$MergeBinaryExpr$bx1().contains(traces$MergeBinaryExpr$bx1_mergebinaryexpr$tracex1)) { }
        else { bx1_binaryexpressionx2.addtraces$MergeBinaryExpr$bx1(traces$MergeBinaryExpr$bx1_mergebinaryexpr$tracex1); }
      }
      else if (bx1_binaryexpressionx2.gettraces$MergeBinaryExpr$bx1().contains(traces$MergeBinaryExpr$bx1_mergebinaryexpr$tracex1))
      { traces$MergeBinaryExpr$bx1_mergebinaryexpr$tracex1.setbx1(bx1_binaryexpressionx2); } 
    }
  }
  for (int _i = 0; _i < copybinaryexpr$traces.size(); _i++)
  { CopyBinaryExpr$trace traces$CopyBinaryExpr$bx_copybinaryexpr$tracex1 = (CopyBinaryExpr$trace) copybinaryexpr$traces.get(_i);
    for (int _j = 0; _j < binaryexpressions.size(); _j++)
    { BinaryExpression bx_binaryexpressionx2 = (BinaryExpression) binaryexpressions.get(_j);
      if (traces$CopyBinaryExpr$bx_copybinaryexpr$tracex1.getbx() == bx_binaryexpressionx2)
      { if (bx_binaryexpressionx2.gettraces$CopyBinaryExpr$bx().contains(traces$CopyBinaryExpr$bx_copybinaryexpr$tracex1)) { }
        else { bx_binaryexpressionx2.addtraces$CopyBinaryExpr$bx(traces$CopyBinaryExpr$bx_copybinaryexpr$tracex1); }
      }
      else if (bx_binaryexpressionx2.gettraces$CopyBinaryExpr$bx().contains(traces$CopyBinaryExpr$bx_copybinaryexpr$tracex1))
      { traces$CopyBinaryExpr$bx_copybinaryexpr$tracex1.setbx(bx_binaryexpressionx2); } 
    }
  }
  }


  public void saveModel(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
  for (int _i = 0; _i < basicexpressions.size(); _i++)
  { BasicExpression basicexpressionx_ = (BasicExpression) basicexpressions.get(_i);
    out.println("basicexpressionx_" + _i + " : BasicExpression");
    out.println("basicexpressionx_" + _i + ".name = \"" + basicexpressionx_.getname() + "\"");
    out.println("basicexpressionx_" + _i + ".value = \"" + basicexpressionx_.getvalue() + "\"");
  }

  for (int _i = 0; _i < binaryexpressions.size(); _i++)
  { BinaryExpression binaryexpressionx_ = (BinaryExpression) binaryexpressions.get(_i);
    out.println("binaryexpressionx_" + _i + " : BinaryExpression");
    out.println("binaryexpressionx_" + _i + ".operator = \"" + binaryexpressionx_.getoperator() + "\"");
  }

  for (int _i = 0; _i < edges.size(); _i++)
  { Edge edgex_ = (Edge) edges.get(_i);
    out.println("edgex_" + _i + " : Edge");
    out.println("edgex_" + _i + ".label = \"" + edgex_.getlabel() + "\"");
  }

  for (int _i = 0; _i < mergebasicexpr$traces.size(); _i++)
  { MergeBasicExpr$trace mergebasicexpr$tracex_ = (MergeBasicExpr$trace) mergebasicexpr$traces.get(_i);
    out.println("mergebasicexpr$tracex_" + _i + " : MergeBasicExpr$trace");
  }

  for (int _i = 0; _i < copybasicexpr$traces.size(); _i++)
  { CopyBasicExpr$trace copybasicexpr$tracex_ = (CopyBasicExpr$trace) copybasicexpr$traces.get(_i);
    out.println("copybasicexpr$tracex_" + _i + " : CopyBasicExpr$trace");
  }

  for (int _i = 0; _i < mergebinaryexpr$traces.size(); _i++)
  { MergeBinaryExpr$trace mergebinaryexpr$tracex_ = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i);
    out.println("mergebinaryexpr$tracex_" + _i + " : MergeBinaryExpr$trace");
  }

  for (int _i = 0; _i < copybinaryexpr$traces.size(); _i++)
  { CopyBinaryExpr$trace copybinaryexpr$tracex_ = (CopyBinaryExpr$trace) copybinaryexpr$traces.get(_i);
    out.println("copybinaryexpr$tracex_" + _i + " : CopyBinaryExpr$trace");
  }

  for (int _i = 0; _i < tau$press.size(); _i++)
  { Tau$Pres tau$presx_ = (Tau$Pres) tau$press.get(_i);
    out.println("tau$presx_" + _i + " : Tau$Pres");
  }

  for (int _i = 0; _i < tau$cons.size(); _i++)
  { Tau$Con tau$conx_ = (Tau$Con) tau$cons.get(_i);
    out.println("tau$conx_" + _i + " : Tau$Con");
  }

  for (int _i = 0; _i < tau$cleanups.size(); _i++)
  { Tau$Cleanup tau$cleanupx_ = (Tau$Cleanup) tau$cleanups.get(_i);
    out.println("tau$cleanupx_" + _i + " : Tau$Cleanup");
  }

  for (int _i = 0; _i < basicexpressions.size(); _i++)
  { BasicExpression basicexpressionx_ = (BasicExpression) basicexpressions.get(_i);
    List basicexpression_traces$MergeBasicExpr$be_MergeBasicExpr$trace = basicexpressionx_.gettraces$MergeBasicExpr$be();
    for (int _j = 0; _j < basicexpression_traces$MergeBasicExpr$be_MergeBasicExpr$trace.size(); _j++)
    { out.println("mergebasicexpr$tracex_" + mergebasicexpr$traces.indexOf(basicexpression_traces$MergeBasicExpr$be_MergeBasicExpr$trace.get(_j)) + " : basicexpressionx_" + _i + ".traces$MergeBasicExpr$be");
    }
    List basicexpression_traces$MergeBasicExpr$be1_MergeBasicExpr$trace = basicexpressionx_.gettraces$MergeBasicExpr$be1();
    for (int _j = 0; _j < basicexpression_traces$MergeBasicExpr$be1_MergeBasicExpr$trace.size(); _j++)
    { out.println("mergebasicexpr$tracex_" + mergebasicexpr$traces.indexOf(basicexpression_traces$MergeBasicExpr$be1_MergeBasicExpr$trace.get(_j)) + " : basicexpressionx_" + _i + ".traces$MergeBasicExpr$be1");
    }
    List basicexpression_traces$CopyBasicExpr$be_CopyBasicExpr$trace = basicexpressionx_.gettraces$CopyBasicExpr$be();
    for (int _j = 0; _j < basicexpression_traces$CopyBasicExpr$be_CopyBasicExpr$trace.size(); _j++)
    { out.println("copybasicexpr$tracex_" + copybasicexpr$traces.indexOf(basicexpression_traces$CopyBasicExpr$be_CopyBasicExpr$trace.get(_j)) + " : basicexpressionx_" + _i + ".traces$CopyBasicExpr$be");
    }
    List basicexpression_incoming_Edge = basicexpressionx_.getincoming();
    for (int _j = 0; _j < basicexpression_incoming_Edge.size(); _j++)
    { out.println("edgex_" + edges.indexOf(basicexpression_incoming_Edge.get(_j)) + " : basicexpressionx_" + _i + ".incoming");
    }
    List basicexpression_outgoing_Edge = basicexpressionx_.getoutgoing();
    for (int _j = 0; _j < basicexpression_outgoing_Edge.size(); _j++)
    { out.println("edgex_" + edges.indexOf(basicexpression_outgoing_Edge.get(_j)) + " : basicexpressionx_" + _i + ".outgoing");
    }
  }
  for (int _i = 0; _i < binaryexpressions.size(); _i++)
  { BinaryExpression binaryexpressionx_ = (BinaryExpression) binaryexpressions.get(_i);
    List binaryexpression_traces$MergeBinaryExpr$bx_MergeBinaryExpr$trace = binaryexpressionx_.gettraces$MergeBinaryExpr$bx();
    for (int _j = 0; _j < binaryexpression_traces$MergeBinaryExpr$bx_MergeBinaryExpr$trace.size(); _j++)
    { out.println("mergebinaryexpr$tracex_" + mergebinaryexpr$traces.indexOf(binaryexpression_traces$MergeBinaryExpr$bx_MergeBinaryExpr$trace.get(_j)) + " : binaryexpressionx_" + _i + ".traces$MergeBinaryExpr$bx");
    }
    List binaryexpression_traces$MergeBinaryExpr$bx1_MergeBinaryExpr$trace = binaryexpressionx_.gettraces$MergeBinaryExpr$bx1();
    for (int _j = 0; _j < binaryexpression_traces$MergeBinaryExpr$bx1_MergeBinaryExpr$trace.size(); _j++)
    { out.println("mergebinaryexpr$tracex_" + mergebinaryexpr$traces.indexOf(binaryexpression_traces$MergeBinaryExpr$bx1_MergeBinaryExpr$trace.get(_j)) + " : binaryexpressionx_" + _i + ".traces$MergeBinaryExpr$bx1");
    }
    List binaryexpression_traces$CopyBinaryExpr$bx_CopyBinaryExpr$trace = binaryexpressionx_.gettraces$CopyBinaryExpr$bx();
    for (int _j = 0; _j < binaryexpression_traces$CopyBinaryExpr$bx_CopyBinaryExpr$trace.size(); _j++)
    { out.println("copybinaryexpr$tracex_" + copybinaryexpr$traces.indexOf(binaryexpression_traces$CopyBinaryExpr$bx_CopyBinaryExpr$trace.get(_j)) + " : binaryexpressionx_" + _i + ".traces$CopyBinaryExpr$bx");
    }
    List binaryexpression_incoming_Edge = binaryexpressionx_.getincoming();
    for (int _j = 0; _j < binaryexpression_incoming_Edge.size(); _j++)
    { out.println("edgex_" + edges.indexOf(binaryexpression_incoming_Edge.get(_j)) + " : binaryexpressionx_" + _i + ".incoming");
    }
    List binaryexpression_outgoing_Edge = binaryexpressionx_.getoutgoing();
    for (int _j = 0; _j < binaryexpression_outgoing_Edge.size(); _j++)
    { out.println("edgex_" + edges.indexOf(binaryexpression_outgoing_Edge.get(_j)) + " : binaryexpressionx_" + _i + ".outgoing");
    }
  }
  for (int _i = 0; _i < edges.size(); _i++)
  { Edge edgex_ = (Edge) edges.get(_i);
    if (edgex_.gettarget() instanceof BasicExpression)
    { out.println("edgex_" + _i + ".target = basicexpressionx_" + basicexpressions.indexOf(edgex_.gettarget())); } 
    if (edgex_.gettarget() instanceof BinaryExpression)
    { out.println("edgex_" + _i + ".target = binaryexpressionx_" + binaryexpressions.indexOf(edgex_.gettarget())); } 
    if (edgex_.getsource() instanceof BasicExpression)
    { out.println("edgex_" + _i + ".source = basicexpressionx_" + basicexpressions.indexOf(edgex_.getsource())); } 
    if (edgex_.getsource() instanceof BinaryExpression)
    { out.println("edgex_" + _i + ".source = binaryexpressionx_" + binaryexpressions.indexOf(edgex_.getsource())); } 
  }
  for (int _i = 0; _i < mergebasicexpr$traces.size(); _i++)
  { MergeBasicExpr$trace mergebasicexpr$tracex_ = (MergeBasicExpr$trace) mergebasicexpr$traces.get(_i);
    out.println("mergebasicexpr$tracex_" + _i + ".be = basicexpressionx_" + basicexpressions.indexOf(((MergeBasicExpr$trace) mergebasicexpr$traces.get(_i)).getbe()));
    out.println("mergebasicexpr$tracex_" + _i + ".be1 = basicexpressionx_" + basicexpressions.indexOf(((MergeBasicExpr$trace) mergebasicexpr$traces.get(_i)).getbe1()));
  }
  for (int _i = 0; _i < copybasicexpr$traces.size(); _i++)
  { CopyBasicExpr$trace copybasicexpr$tracex_ = (CopyBasicExpr$trace) copybasicexpr$traces.get(_i);
    out.println("copybasicexpr$tracex_" + _i + ".be = basicexpressionx_" + basicexpressions.indexOf(((CopyBasicExpr$trace) copybasicexpr$traces.get(_i)).getbe()));
  }
  for (int _i = 0; _i < mergebinaryexpr$traces.size(); _i++)
  { MergeBinaryExpr$trace mergebinaryexpr$tracex_ = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i);
    out.println("mergebinaryexpr$tracex_" + _i + ".bx = binaryexpressionx_" + binaryexpressions.indexOf(((MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i)).getbx()));
    out.println("mergebinaryexpr$tracex_" + _i + ".bx1 = binaryexpressionx_" + binaryexpressions.indexOf(((MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i)).getbx1()));
  }
  for (int _i = 0; _i < copybinaryexpr$traces.size(); _i++)
  { CopyBinaryExpr$trace copybinaryexpr$tracex_ = (CopyBinaryExpr$trace) copybinaryexpr$traces.get(_i);
    out.println("copybinaryexpr$tracex_" + _i + ".bx = binaryexpressionx_" + binaryexpressions.indexOf(((CopyBinaryExpr$trace) copybinaryexpr$traces.get(_i)).getbx()));
  }
    out.close(); 
  }


  public static void loadXSI()
  { boolean __eof = false;
    String __s = "";
    String xmlstring = "";
    BufferedReader __br = null;
    try
    { File _classmodel = new File("in.xmi");
      __br = new BufferedReader(new FileReader(_classmodel));
      __eof = false;
      while (!__eof)
      { try { __s = __br.readLine(); }
        catch (IOException __e)
        { System.out.println("Reading failed.");
          return;
        }
        if (__s == null)
        { __eof = true; }
        else
        { xmlstring = xmlstring + __s; }
      } 
      __br.close();
    } 
    catch (Exception _x) { }
    Vector res = convertXsiToVector(xmlstring);
    File outfile = new File("_in.txt");
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
    for (int i = 0; i < res.size(); i++)
    { String r = (String) res.get(i); 
      out.println(r);
    } 
    out.close();
    loadModel("_in.txt");
  }

  public static Vector convertXsiToVector(String xmlstring)
  { Vector res = new Vector();
    XMLParser comp = new XMLParser();
    comp.nospacelexicalanalysisxml(xmlstring);
    XMLNode xml = comp.parseXML();
    if (xml == null) { return res; } 
    java.util.Map instancemap = new java.util.HashMap(); // String --> Vector
    java.util.Map entmap = new java.util.HashMap();       // String --> String
    Vector entcodes = new Vector(); 
    java.util.Map allattsmap = new java.util.HashMap(); // String --> Vector
    java.util.Map stringattsmap = new java.util.HashMap(); // String --> Vector
    java.util.Map onerolesmap = new java.util.HashMap(); // String --> Vector
    java.util.Map actualtype = new java.util.HashMap(); // XMLNode --> String
    Vector eallatts = new Vector();
    instancemap.put("expressions", new Vector()); 
    instancemap.put("expression",new Vector()); 
    entcodes.add("expressions");
    entcodes.add("expression");
    entmap.put("expressions","Expression");
    entmap.put("expression","Expression");
    eallatts = new Vector();
    allattsmap.put("Expression", eallatts);
    eallatts = new Vector();
    stringattsmap.put("Expression", eallatts);
    eallatts = new Vector();
    onerolesmap.put("Expression", eallatts);
    instancemap.put("basicexpressions", new Vector()); 
    instancemap.put("basicexpression",new Vector()); 
    entcodes.add("basicexpressions");
    entcodes.add("basicexpression");
    entmap.put("basicexpressions","BasicExpression");
    entmap.put("basicexpression","BasicExpression");
    eallatts = new Vector();
    eallatts.add("name");
    eallatts.add("value");
    allattsmap.put("BasicExpression", eallatts);
    eallatts = new Vector();
    eallatts.add("name");
    eallatts.add("value");
    stringattsmap.put("BasicExpression", eallatts);
    eallatts = new Vector();
    onerolesmap.put("BasicExpression", eallatts);
    instancemap.put("binaryexpressions", new Vector()); 
    instancemap.put("binaryexpression",new Vector()); 
    entcodes.add("binaryexpressions");
    entcodes.add("binaryexpression");
    entmap.put("binaryexpressions","BinaryExpression");
    entmap.put("binaryexpression","BinaryExpression");
    eallatts = new Vector();
    eallatts.add("operator");
    allattsmap.put("BinaryExpression", eallatts);
    eallatts = new Vector();
    eallatts.add("operator");
    stringattsmap.put("BinaryExpression", eallatts);
    eallatts = new Vector();
    onerolesmap.put("BinaryExpression", eallatts);
    instancemap.put("edges", new Vector()); 
    instancemap.put("edge",new Vector()); 
    entcodes.add("edges");
    entcodes.add("edge");
    entmap.put("edges","Edge");
    entmap.put("edge","Edge");
    eallatts = new Vector();
    eallatts.add("label");
    allattsmap.put("Edge", eallatts);
    eallatts = new Vector();
    eallatts.add("label");
    stringattsmap.put("Edge", eallatts);
    eallatts = new Vector();
    eallatts.add("target");
    eallatts.add("source");
    onerolesmap.put("Edge", eallatts);
    instancemap.put("mergebasicexpr$traces", new Vector()); 
    instancemap.put("mergebasicexpr$trace",new Vector()); 
    entcodes.add("mergebasicexpr$traces");
    entcodes.add("mergebasicexpr$trace");
    entmap.put("mergebasicexpr$traces","MergeBasicExpr$trace");
    entmap.put("mergebasicexpr$trace","MergeBasicExpr$trace");
    eallatts = new Vector();
    allattsmap.put("MergeBasicExpr$trace", eallatts);
    eallatts = new Vector();
    stringattsmap.put("MergeBasicExpr$trace", eallatts);
    eallatts = new Vector();
    eallatts.add("be");
    eallatts.add("be1");
    onerolesmap.put("MergeBasicExpr$trace", eallatts);
    instancemap.put("copybasicexpr$traces", new Vector()); 
    instancemap.put("copybasicexpr$trace",new Vector()); 
    entcodes.add("copybasicexpr$traces");
    entcodes.add("copybasicexpr$trace");
    entmap.put("copybasicexpr$traces","CopyBasicExpr$trace");
    entmap.put("copybasicexpr$trace","CopyBasicExpr$trace");
    eallatts = new Vector();
    allattsmap.put("CopyBasicExpr$trace", eallatts);
    eallatts = new Vector();
    stringattsmap.put("CopyBasicExpr$trace", eallatts);
    eallatts = new Vector();
    eallatts.add("be");
    onerolesmap.put("CopyBasicExpr$trace", eallatts);
    instancemap.put("mergebinaryexpr$traces", new Vector()); 
    instancemap.put("mergebinaryexpr$trace",new Vector()); 
    entcodes.add("mergebinaryexpr$traces");
    entcodes.add("mergebinaryexpr$trace");
    entmap.put("mergebinaryexpr$traces","MergeBinaryExpr$trace");
    entmap.put("mergebinaryexpr$trace","MergeBinaryExpr$trace");
    eallatts = new Vector();
    allattsmap.put("MergeBinaryExpr$trace", eallatts);
    eallatts = new Vector();
    stringattsmap.put("MergeBinaryExpr$trace", eallatts);
    eallatts = new Vector();
    eallatts.add("bx");
    eallatts.add("bx1");
    onerolesmap.put("MergeBinaryExpr$trace", eallatts);
    instancemap.put("copybinaryexpr$traces", new Vector()); 
    instancemap.put("copybinaryexpr$trace",new Vector()); 
    entcodes.add("copybinaryexpr$traces");
    entcodes.add("copybinaryexpr$trace");
    entmap.put("copybinaryexpr$traces","CopyBinaryExpr$trace");
    entmap.put("copybinaryexpr$trace","CopyBinaryExpr$trace");
    eallatts = new Vector();
    allattsmap.put("CopyBinaryExpr$trace", eallatts);
    eallatts = new Vector();
    stringattsmap.put("CopyBinaryExpr$trace", eallatts);
    eallatts = new Vector();
    eallatts.add("bx");
    onerolesmap.put("CopyBinaryExpr$trace", eallatts);
    instancemap.put("tau$press", new Vector()); 
    instancemap.put("tau$pres",new Vector()); 
    entcodes.add("tau$press");
    entcodes.add("tau$pres");
    entmap.put("tau$press","Tau$Pres");
    entmap.put("tau$pres","Tau$Pres");
    eallatts = new Vector();
    allattsmap.put("Tau$Pres", eallatts);
    eallatts = new Vector();
    stringattsmap.put("Tau$Pres", eallatts);
    eallatts = new Vector();
    onerolesmap.put("Tau$Pres", eallatts);
    instancemap.put("tau$cons", new Vector()); 
    instancemap.put("tau$con",new Vector()); 
    entcodes.add("tau$cons");
    entcodes.add("tau$con");
    entmap.put("tau$cons","Tau$Con");
    entmap.put("tau$con","Tau$Con");
    eallatts = new Vector();
    allattsmap.put("Tau$Con", eallatts);
    eallatts = new Vector();
    stringattsmap.put("Tau$Con", eallatts);
    eallatts = new Vector();
    onerolesmap.put("Tau$Con", eallatts);
    instancemap.put("tau$cleanups", new Vector()); 
    instancemap.put("tau$cleanup",new Vector()); 
    entcodes.add("tau$cleanups");
    entcodes.add("tau$cleanup");
    entmap.put("tau$cleanups","Tau$Cleanup");
    entmap.put("tau$cleanup","Tau$Cleanup");
    eallatts = new Vector();
    allattsmap.put("Tau$Cleanup", eallatts);
    eallatts = new Vector();
    stringattsmap.put("Tau$Cleanup", eallatts);
    eallatts = new Vector();
    onerolesmap.put("Tau$Cleanup", eallatts);
    eallatts = new Vector();
  Vector enodes = xml.getSubnodes();
  for (int i = 0; i < enodes.size(); i++)
  { XMLNode enode = (XMLNode) enodes.get(i);
    String cname = enode.getTag();
    Vector einstances = (Vector) instancemap.get(cname); 
    if (einstances == null) 
    { einstances = (Vector) instancemap.get(cname + "s"); }
    if (einstances != null) 
    { einstances.add(enode); }
  }
  for (int j = 0; j < entcodes.size(); j++)
  { String ename = (String) entcodes.get(j);
    Vector elems = (Vector) instancemap.get(ename);
    for (int k = 0; k < elems.size(); k++)
    { XMLNode enode = (XMLNode) elems.get(k);
      String tname = enode.getAttributeValue("xsi:type"); 
      if (tname == null) 
      { tname = (String) entmap.get(ename); } 
      else 
      { int colonind = tname.indexOf(":"); 
        if (colonind >= 0)
        { tname = tname.substring(colonind + 1,tname.length()); }
      }
      res.add(ename + k + " : " + tname);
      actualtype.put(enode,tname);
    }   
  }
  for (int j = 0; j < entcodes.size(); j++) 
  { String ename = (String) entcodes.get(j); 
    Vector elems = (Vector) instancemap.get(ename); 
    for (int k = 0; k < elems.size(); k++)
    { XMLNode enode = (XMLNode) elems.get(k);
      String tname = (String) actualtype.get(enode);
      Vector tallatts = (Vector)  allattsmap.get(tname);
      Vector tstringatts = (Vector)  stringattsmap.get(tname);
      Vector toneroles = (Vector)  onerolesmap.get(tname);
      Vector atts = enode.getAttributes();
      for (int p = 0; p < atts.size(); p++) 
      { XMLAttribute patt = (XMLAttribute) atts.get(p); 
        if (patt.getName().equals("xsi:type") || patt.getName().equals("xmi:id")) {} 
        else 
        { patt.getDataDeclarationFromXsi(res,tallatts,tstringatts,toneroles,ename + k, (String) entmap.get(ename)); } 
      }
    } 
  }  
  return res; } 

  public void saveXSI(String file)
  { File outfile = new File(file); 
    PrintWriter out; 
    try { out = new PrintWriter(new BufferedWriter(new FileWriter(outfile))); }
    catch (Exception e) { return; } 
    out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
    out.println("<UMLRSDS:model xmi:version=\"2.0\" xmlns:xmi=\"http://www.omg.org/XMI\">");
    for (int _i = 0; _i < basicexpressions.size(); _i++)
    { BasicExpression basicexpressionx_ = (BasicExpression) basicexpressions.get(_i);
       out.print("<basicexpressions xsi:type=\"My:BasicExpression\"");
    out.print(" name=\"" + basicexpressionx_.getname() + "\" ");
    out.print(" value=\"" + basicexpressionx_.getvalue() + "\" ");
    out.print(" traces$MergeBasicExpr$be = \"");
    List basicexpression_traces$MergeBasicExpr$be = basicexpressionx_.gettraces$MergeBasicExpr$be();
    for (int _j = 0; _j < basicexpression_traces$MergeBasicExpr$be.size(); _j++)
    { out.print(" //@mergebasicexpr$traces." + mergebasicexpr$traces.indexOf(basicexpression_traces$MergeBasicExpr$be.get(_j)));
    }
    out.print("\"");
    out.print(" traces$MergeBasicExpr$be1 = \"");
    List basicexpression_traces$MergeBasicExpr$be1 = basicexpressionx_.gettraces$MergeBasicExpr$be1();
    for (int _j = 0; _j < basicexpression_traces$MergeBasicExpr$be1.size(); _j++)
    { out.print(" //@mergebasicexpr$traces." + mergebasicexpr$traces.indexOf(basicexpression_traces$MergeBasicExpr$be1.get(_j)));
    }
    out.print("\"");
    out.print(" traces$CopyBasicExpr$be = \"");
    List basicexpression_traces$CopyBasicExpr$be = basicexpressionx_.gettraces$CopyBasicExpr$be();
    for (int _j = 0; _j < basicexpression_traces$CopyBasicExpr$be.size(); _j++)
    { out.print(" //@copybasicexpr$traces." + copybasicexpr$traces.indexOf(basicexpression_traces$CopyBasicExpr$be.get(_j)));
    }
    out.print("\"");
    out.print(" incoming = \"");
    List basicexpression_incoming = basicexpressionx_.getincoming();
    for (int _j = 0; _j < basicexpression_incoming.size(); _j++)
    { out.print(" //@edges." + edges.indexOf(basicexpression_incoming.get(_j)));
    }
    out.print("\"");
    out.print(" outgoing = \"");
    List basicexpression_outgoing = basicexpressionx_.getoutgoing();
    for (int _j = 0; _j < basicexpression_outgoing.size(); _j++)
    { out.print(" //@edges." + edges.indexOf(basicexpression_outgoing.get(_j)));
    }
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < binaryexpressions.size(); _i++)
    { BinaryExpression binaryexpressionx_ = (BinaryExpression) binaryexpressions.get(_i);
       out.print("<binaryexpressions xsi:type=\"My:BinaryExpression\"");
    out.print(" operator=\"" + binaryexpressionx_.getoperator() + "\" ");
    out.print(" traces$MergeBinaryExpr$bx = \"");
    List binaryexpression_traces$MergeBinaryExpr$bx = binaryexpressionx_.gettraces$MergeBinaryExpr$bx();
    for (int _j = 0; _j < binaryexpression_traces$MergeBinaryExpr$bx.size(); _j++)
    { out.print(" //@mergebinaryexpr$traces." + mergebinaryexpr$traces.indexOf(binaryexpression_traces$MergeBinaryExpr$bx.get(_j)));
    }
    out.print("\"");
    out.print(" traces$MergeBinaryExpr$bx1 = \"");
    List binaryexpression_traces$MergeBinaryExpr$bx1 = binaryexpressionx_.gettraces$MergeBinaryExpr$bx1();
    for (int _j = 0; _j < binaryexpression_traces$MergeBinaryExpr$bx1.size(); _j++)
    { out.print(" //@mergebinaryexpr$traces." + mergebinaryexpr$traces.indexOf(binaryexpression_traces$MergeBinaryExpr$bx1.get(_j)));
    }
    out.print("\"");
    out.print(" traces$CopyBinaryExpr$bx = \"");
    List binaryexpression_traces$CopyBinaryExpr$bx = binaryexpressionx_.gettraces$CopyBinaryExpr$bx();
    for (int _j = 0; _j < binaryexpression_traces$CopyBinaryExpr$bx.size(); _j++)
    { out.print(" //@copybinaryexpr$traces." + copybinaryexpr$traces.indexOf(binaryexpression_traces$CopyBinaryExpr$bx.get(_j)));
    }
    out.print("\"");
    out.print(" incoming = \"");
    List binaryexpression_incoming = binaryexpressionx_.getincoming();
    for (int _j = 0; _j < binaryexpression_incoming.size(); _j++)
    { out.print(" //@edges." + edges.indexOf(binaryexpression_incoming.get(_j)));
    }
    out.print("\"");
    out.print(" outgoing = \"");
    List binaryexpression_outgoing = binaryexpressionx_.getoutgoing();
    for (int _j = 0; _j < binaryexpression_outgoing.size(); _j++)
    { out.print(" //@edges." + edges.indexOf(binaryexpression_outgoing.get(_j)));
    }
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < edges.size(); _i++)
    { Edge edgex_ = (Edge) edges.get(_i);
       out.print("<edges xsi:type=\"My:Edge\"");
    out.print(" label=\"" + edgex_.getlabel() + "\" ");
    if (edgex_.gettarget() instanceof BasicExpression)
    {   out.print(" target=\"");
    out.print("//@basicexpressions." + basicexpressions.indexOf(((Edge) edges.get(_i)).gettarget()));
    out.print("\""); }
 else    if (edgex_.gettarget() instanceof BinaryExpression)
    {   out.print(" target=\"");
    out.print("//@binaryexpressions." + binaryexpressions.indexOf(((Edge) edges.get(_i)).gettarget()));
    out.print("\""); }
    if (edgex_.getsource() instanceof BasicExpression)
    {   out.print(" source=\"");
    out.print("//@basicexpressions." + basicexpressions.indexOf(((Edge) edges.get(_i)).getsource()));
    out.print("\""); }
 else    if (edgex_.getsource() instanceof BinaryExpression)
    {   out.print(" source=\"");
    out.print("//@binaryexpressions." + binaryexpressions.indexOf(((Edge) edges.get(_i)).getsource()));
    out.print("\""); }
    out.println(" />");
  }

    for (int _i = 0; _i < mergebasicexpr$traces.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracex_ = (MergeBasicExpr$trace) mergebasicexpr$traces.get(_i);
       out.print("<mergebasicexpr$traces xsi:type=\"My:MergeBasicExpr$trace\"");
    out.print(" be=\"");
    out.print("//@basicexpressions." + basicexpressions.indexOf(((MergeBasicExpr$trace) mergebasicexpr$traces.get(_i)).getbe()));
    out.print("\"");
    out.print(" be1=\"");
    out.print("//@basicexpressions." + basicexpressions.indexOf(((MergeBasicExpr$trace) mergebasicexpr$traces.get(_i)).getbe1()));
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < copybasicexpr$traces.size(); _i++)
    { CopyBasicExpr$trace copybasicexpr$tracex_ = (CopyBasicExpr$trace) copybasicexpr$traces.get(_i);
       out.print("<copybasicexpr$traces xsi:type=\"My:CopyBasicExpr$trace\"");
    out.print(" be=\"");
    out.print("//@basicexpressions." + basicexpressions.indexOf(((CopyBasicExpr$trace) copybasicexpr$traces.get(_i)).getbe()));
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < mergebinaryexpr$traces.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracex_ = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i);
       out.print("<mergebinaryexpr$traces xsi:type=\"My:MergeBinaryExpr$trace\"");
    out.print(" bx=\"");
    out.print("//@binaryexpressions." + binaryexpressions.indexOf(((MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i)).getbx()));
    out.print("\"");
    out.print(" bx1=\"");
    out.print("//@binaryexpressions." + binaryexpressions.indexOf(((MergeBinaryExpr$trace) mergebinaryexpr$traces.get(_i)).getbx1()));
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < copybinaryexpr$traces.size(); _i++)
    { CopyBinaryExpr$trace copybinaryexpr$tracex_ = (CopyBinaryExpr$trace) copybinaryexpr$traces.get(_i);
       out.print("<copybinaryexpr$traces xsi:type=\"My:CopyBinaryExpr$trace\"");
    out.print(" bx=\"");
    out.print("//@binaryexpressions." + binaryexpressions.indexOf(((CopyBinaryExpr$trace) copybinaryexpr$traces.get(_i)).getbx()));
    out.print("\"");
    out.println(" />");
  }

    for (int _i = 0; _i < tau$press.size(); _i++)
    { Tau$Pres tau$presx_ = (Tau$Pres) tau$press.get(_i);
       out.print("<tau$press xsi:type=\"My:Tau$Pres\"");
    out.println(" />");
  }

    for (int _i = 0; _i < tau$cons.size(); _i++)
    { Tau$Con tau$conx_ = (Tau$Con) tau$cons.get(_i);
       out.print("<tau$cons xsi:type=\"My:Tau$Con\"");
    out.println(" />");
  }

    for (int _i = 0; _i < tau$cleanups.size(); _i++)
    { Tau$Cleanup tau$cleanupx_ = (Tau$Cleanup) tau$cleanups.get(_i);
       out.print("<tau$cleanups xsi:type=\"My:Tau$Cleanup\"");
    out.println(" />");
  }

    out.println("</UMLRSDS:model>");
    out.close(); 
  }


  public void saveCSVModel()
  { try {
      File _basicexpression = new File("BasicExpression.csv");
      PrintWriter _out_basicexpression = new PrintWriter(new BufferedWriter(new FileWriter(_basicexpression)));
      for (int __i = 0; __i < basicexpressions.size(); __i++)
      { BasicExpression basicexpressionx = (BasicExpression) basicexpressions.get(__i);
        basicexpressionx.writeCSV(_out_basicexpression);
      }
      _out_basicexpression.close();
      File _binaryexpression = new File("BinaryExpression.csv");
      PrintWriter _out_binaryexpression = new PrintWriter(new BufferedWriter(new FileWriter(_binaryexpression)));
      for (int __i = 0; __i < binaryexpressions.size(); __i++)
      { BinaryExpression binaryexpressionx = (BinaryExpression) binaryexpressions.get(__i);
        binaryexpressionx.writeCSV(_out_binaryexpression);
      }
      _out_binaryexpression.close();
      File _edge = new File("Edge.csv");
      PrintWriter _out_edge = new PrintWriter(new BufferedWriter(new FileWriter(_edge)));
      for (int __i = 0; __i < edges.size(); __i++)
      { Edge edgex = (Edge) edges.get(__i);
        edgex.writeCSV(_out_edge);
      }
      _out_edge.close();
      File _mergebasicexpr$trace = new File("MergeBasicExpr$trace.csv");
      PrintWriter _out_mergebasicexpr$trace = new PrintWriter(new BufferedWriter(new FileWriter(_mergebasicexpr$trace)));
      for (int __i = 0; __i < mergebasicexpr$traces.size(); __i++)
      { MergeBasicExpr$trace mergebasicexpr$tracex = (MergeBasicExpr$trace) mergebasicexpr$traces.get(__i);
        mergebasicexpr$tracex.writeCSV(_out_mergebasicexpr$trace);
      }
      _out_mergebasicexpr$trace.close();
      File _copybasicexpr$trace = new File("CopyBasicExpr$trace.csv");
      PrintWriter _out_copybasicexpr$trace = new PrintWriter(new BufferedWriter(new FileWriter(_copybasicexpr$trace)));
      for (int __i = 0; __i < copybasicexpr$traces.size(); __i++)
      { CopyBasicExpr$trace copybasicexpr$tracex = (CopyBasicExpr$trace) copybasicexpr$traces.get(__i);
        copybasicexpr$tracex.writeCSV(_out_copybasicexpr$trace);
      }
      _out_copybasicexpr$trace.close();
      File _mergebinaryexpr$trace = new File("MergeBinaryExpr$trace.csv");
      PrintWriter _out_mergebinaryexpr$trace = new PrintWriter(new BufferedWriter(new FileWriter(_mergebinaryexpr$trace)));
      for (int __i = 0; __i < mergebinaryexpr$traces.size(); __i++)
      { MergeBinaryExpr$trace mergebinaryexpr$tracex = (MergeBinaryExpr$trace) mergebinaryexpr$traces.get(__i);
        mergebinaryexpr$tracex.writeCSV(_out_mergebinaryexpr$trace);
      }
      _out_mergebinaryexpr$trace.close();
      File _copybinaryexpr$trace = new File("CopyBinaryExpr$trace.csv");
      PrintWriter _out_copybinaryexpr$trace = new PrintWriter(new BufferedWriter(new FileWriter(_copybinaryexpr$trace)));
      for (int __i = 0; __i < copybinaryexpr$traces.size(); __i++)
      { CopyBinaryExpr$trace copybinaryexpr$tracex = (CopyBinaryExpr$trace) copybinaryexpr$traces.get(__i);
        copybinaryexpr$tracex.writeCSV(_out_copybinaryexpr$trace);
      }
      _out_copybinaryexpr$trace.close();
      File _tau$pres = new File("Tau$Pres.csv");
      PrintWriter _out_tau$pres = new PrintWriter(new BufferedWriter(new FileWriter(_tau$pres)));
      for (int __i = 0; __i < tau$press.size(); __i++)
      { Tau$Pres tau$presx = (Tau$Pres) tau$press.get(__i);
        tau$presx.writeCSV(_out_tau$pres);
      }
      _out_tau$pres.close();
      File _tau$con = new File("Tau$Con.csv");
      PrintWriter _out_tau$con = new PrintWriter(new BufferedWriter(new FileWriter(_tau$con)));
      for (int __i = 0; __i < tau$cons.size(); __i++)
      { Tau$Con tau$conx = (Tau$Con) tau$cons.get(__i);
        tau$conx.writeCSV(_out_tau$con);
      }
      _out_tau$con.close();
      File _tau$cleanup = new File("Tau$Cleanup.csv");
      PrintWriter _out_tau$cleanup = new PrintWriter(new BufferedWriter(new FileWriter(_tau$cleanup)));
      for (int __i = 0; __i < tau$cleanups.size(); __i++)
      { Tau$Cleanup tau$cleanupx = (Tau$Cleanup) tau$cleanups.get(__i);
        tau$cleanupx.writeCSV(_out_tau$cleanup);
      }
      _out_tau$cleanup.close();
    }
    catch(Exception __e) { }
  }



  public void addExpression(Expression oo) { expressions.add(oo); }

  public void addBasicExpression(BasicExpression oo) { basicexpressions.add(oo); addExpression(oo); }

  public void addBinaryExpression(BinaryExpression oo) { binaryexpressions.add(oo); addExpression(oo); }

  public void addEdge(Edge oo) { edges.add(oo); }

  public void addMergeBasicExpr$trace(MergeBasicExpr$trace oo) { mergebasicexpr$traces.add(oo); }

  public void addCopyBasicExpr$trace(CopyBasicExpr$trace oo) { copybasicexpr$traces.add(oo); }

  public void addMergeBinaryExpr$trace(MergeBinaryExpr$trace oo) { mergebinaryexpr$traces.add(oo); }

  public void addCopyBinaryExpr$trace(CopyBinaryExpr$trace oo) { copybinaryexpr$traces.add(oo); }

  public void addTau$Pres(Tau$Pres oo) { tau$press.add(oo); }

  public void addTau$Con(Tau$Con oo) { tau$cons.add(oo); }

  public void addTau$Cleanup(Tau$Cleanup oo) { tau$cleanups.add(oo); }



  public BasicExpression createBasicExpression()
  { BasicExpression basicexpressionx = new BasicExpression();
    addBasicExpression(basicexpressionx);
    return basicexpressionx;
  }

  public BinaryExpression createBinaryExpression()
  { BinaryExpression binaryexpressionx = new BinaryExpression();
    addBinaryExpression(binaryexpressionx);
    return binaryexpressionx;
  }

  public Edge createEdge()
  { Edge edgex = new Edge();
    addEdge(edgex);
    return edgex;
  }

  public MergeBasicExpr$trace createMergeBasicExpr$trace()
  { MergeBasicExpr$trace mergebasicexpr$tracex = new MergeBasicExpr$trace();
    addMergeBasicExpr$trace(mergebasicexpr$tracex);
    return mergebasicexpr$tracex;
  }

  public CopyBasicExpr$trace createCopyBasicExpr$trace()
  { CopyBasicExpr$trace copybasicexpr$tracex = new CopyBasicExpr$trace();
    addCopyBasicExpr$trace(copybasicexpr$tracex);
    return copybasicexpr$tracex;
  }

  public MergeBinaryExpr$trace createMergeBinaryExpr$trace()
  { MergeBinaryExpr$trace mergebinaryexpr$tracex = new MergeBinaryExpr$trace();
    addMergeBinaryExpr$trace(mergebinaryexpr$tracex);
    return mergebinaryexpr$tracex;
  }

  public CopyBinaryExpr$trace createCopyBinaryExpr$trace()
  { CopyBinaryExpr$trace copybinaryexpr$tracex = new CopyBinaryExpr$trace();
    addCopyBinaryExpr$trace(copybinaryexpr$tracex);
    return copybinaryexpr$tracex;
  }

  public Tau$Pres createTau$Pres()
  { Tau$Pres tau$presx = new Tau$Pres();
    addTau$Pres(tau$presx);
    return tau$presx;
  }

  public Tau$Con createTau$Con()
  { Tau$Con tau$conx = new Tau$Con();
    addTau$Con(tau$conx);
    return tau$conx;
  }

  public Tau$Cleanup createTau$Cleanup()
  { Tau$Cleanup tau$cleanupx = new Tau$Cleanup();
    addTau$Cleanup(tau$cleanupx);
    return tau$cleanupx;
  }


  public void setincoming(Expression expressionx, List incomingxx) 
  {   List _oldincomingxx = expressionx.getincoming();
    for (int _j = 0; _j < _oldincomingxx.size(); _j++)
    { Edge _yy = (Edge) _oldincomingxx.get(_j);
      if (incomingxx.contains(_yy)) { }
      else { _yy.settarget(null); }
    }
  for (int _i = 0; _i < incomingxx.size(); _i++)
  { Edge _xx = (Edge) incomingxx.get(_i);
    if (_oldincomingxx.contains(_xx)) { }
    else { if (_xx.gettarget() != null) { _xx.gettarget().removeincoming(_xx); }  }
    _xx.settarget(expressionx);
  }
    expressionx.setincoming(incomingxx);
      }


  public void addincoming(Expression expressionx, Edge incomingxx) 
  { if (expressionx.getincoming().contains(incomingxx)) { return; }
    if (incomingxx.gettarget() != null) { incomingxx.gettarget().removeincoming(incomingxx); }
  incomingxx.settarget(expressionx);
    expressionx.addincoming(incomingxx);
   }


  public void removeincoming(Expression expressionx, Edge incomingxx) 
  { expressionx.removeincoming(incomingxx);
      incomingxx.settarget(null);
  }


 public void unionincoming(Expression expressionx, List incomingx)
  { for (int _i = 0; _i < incomingx.size(); _i++)
    { Edge edgexincoming = (Edge) incomingx.get(_i);
      addincoming(expressionx, edgexincoming);
     } } 


 public void subtractincoming(Expression expressionx, List incomingx)
  { for (int _i = 0; _i < incomingx.size(); _i++)
    { Edge edgexincoming = (Edge) incomingx.get(_i);
      removeincoming(expressionx, edgexincoming);
     } } 


  public void setoutgoing(Expression expressionx, List outgoingxx) 
  {   List _oldoutgoingxx = expressionx.getoutgoing();
    for (int _j = 0; _j < _oldoutgoingxx.size(); _j++)
    { Edge _yy = (Edge) _oldoutgoingxx.get(_j);
      if (outgoingxx.contains(_yy)) { }
      else { _yy.setsource(null); }
    }
  for (int _i = 0; _i < outgoingxx.size(); _i++)
  { Edge _xx = (Edge) outgoingxx.get(_i);
    if (_oldoutgoingxx.contains(_xx)) { }
    else { if (_xx.getsource() != null) { _xx.getsource().removeoutgoing(_xx); }  }
    _xx.setsource(expressionx);
  }
    expressionx.setoutgoing(outgoingxx);
      }


  public void addoutgoing(Expression expressionx, Edge outgoingxx) 
  { if (expressionx.getoutgoing().contains(outgoingxx)) { return; }
    if (outgoingxx.getsource() != null) { outgoingxx.getsource().removeoutgoing(outgoingxx); }
  outgoingxx.setsource(expressionx);
    expressionx.addoutgoing(outgoingxx);
   }


  public void removeoutgoing(Expression expressionx, Edge outgoingxx) 
  { expressionx.removeoutgoing(outgoingxx);
      outgoingxx.setsource(null);
  }


 public void unionoutgoing(Expression expressionx, List outgoingx)
  { for (int _i = 0; _i < outgoingx.size(); _i++)
    { Edge edgexoutgoing = (Edge) outgoingx.get(_i);
      addoutgoing(expressionx, edgexoutgoing);
     } } 


 public void subtractoutgoing(Expression expressionx, List outgoingx)
  { for (int _i = 0; _i < outgoingx.size(); _i++)
    { Edge edgexoutgoing = (Edge) outgoingx.get(_i);
      removeoutgoing(expressionx, edgexoutgoing);
     } } 


public void setname(BasicExpression basicexpressionx, String name_x) 
  { basicexpressionx.setname(name_x);
    }


public void setvalue(BasicExpression basicexpressionx, String value_x) 
  { basicexpressionx.setvalue(value_x);
    }


  public void settraces$MergeBasicExpr$be(BasicExpression basicexpressionx, List traces$MergeBasicExpr$bexx) 
  {   List _oldtraces$MergeBasicExpr$bexx = basicexpressionx.gettraces$MergeBasicExpr$be();
    for (int _j = 0; _j < _oldtraces$MergeBasicExpr$bexx.size(); _j++)
    { MergeBasicExpr$trace _yy = (MergeBasicExpr$trace) _oldtraces$MergeBasicExpr$bexx.get(_j);
      if (traces$MergeBasicExpr$bexx.contains(_yy)) { }
      else { _yy.setbe(null); }
    }
  for (int _i = 0; _i < traces$MergeBasicExpr$bexx.size(); _i++)
  { MergeBasicExpr$trace _xx = (MergeBasicExpr$trace) traces$MergeBasicExpr$bexx.get(_i);
    if (_oldtraces$MergeBasicExpr$bexx.contains(_xx)) { }
    else { if (_xx.getbe() != null) { _xx.getbe().removetraces$MergeBasicExpr$be(_xx); }  }
    _xx.setbe(basicexpressionx);
  }
    basicexpressionx.settraces$MergeBasicExpr$be(traces$MergeBasicExpr$bexx);
      }


  public void addtraces$MergeBasicExpr$be(BasicExpression basicexpressionx, MergeBasicExpr$trace traces$MergeBasicExpr$bexx) 
  { if (basicexpressionx.gettraces$MergeBasicExpr$be().contains(traces$MergeBasicExpr$bexx)) { return; }
    if (traces$MergeBasicExpr$bexx.getbe() != null) { traces$MergeBasicExpr$bexx.getbe().removetraces$MergeBasicExpr$be(traces$MergeBasicExpr$bexx); }
  traces$MergeBasicExpr$bexx.setbe(basicexpressionx);
    basicexpressionx.addtraces$MergeBasicExpr$be(traces$MergeBasicExpr$bexx);
   }


  public void removetraces$MergeBasicExpr$be(BasicExpression basicexpressionx, MergeBasicExpr$trace traces$MergeBasicExpr$bexx) 
  { basicexpressionx.removetraces$MergeBasicExpr$be(traces$MergeBasicExpr$bexx);
      traces$MergeBasicExpr$bexx.setbe(null);
  }


 public void uniontraces$MergeBasicExpr$be(BasicExpression basicexpressionx, List traces$MergeBasicExpr$bex)
  { for (int _i = 0; _i < traces$MergeBasicExpr$bex.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracextraces$MergeBasicExpr$be = (MergeBasicExpr$trace) traces$MergeBasicExpr$bex.get(_i);
      addtraces$MergeBasicExpr$be(basicexpressionx, mergebasicexpr$tracextraces$MergeBasicExpr$be);
     } } 


 public void subtracttraces$MergeBasicExpr$be(BasicExpression basicexpressionx, List traces$MergeBasicExpr$bex)
  { for (int _i = 0; _i < traces$MergeBasicExpr$bex.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracextraces$MergeBasicExpr$be = (MergeBasicExpr$trace) traces$MergeBasicExpr$bex.get(_i);
      removetraces$MergeBasicExpr$be(basicexpressionx, mergebasicexpr$tracextraces$MergeBasicExpr$be);
     } } 


  public void settraces$MergeBasicExpr$be1(BasicExpression basicexpressionx, List traces$MergeBasicExpr$be1xx) 
  {   List _oldtraces$MergeBasicExpr$be1xx = basicexpressionx.gettraces$MergeBasicExpr$be1();
    for (int _j = 0; _j < _oldtraces$MergeBasicExpr$be1xx.size(); _j++)
    { MergeBasicExpr$trace _yy = (MergeBasicExpr$trace) _oldtraces$MergeBasicExpr$be1xx.get(_j);
      if (traces$MergeBasicExpr$be1xx.contains(_yy)) { }
      else { _yy.setbe1(null); }
    }
  for (int _i = 0; _i < traces$MergeBasicExpr$be1xx.size(); _i++)
  { MergeBasicExpr$trace _xx = (MergeBasicExpr$trace) traces$MergeBasicExpr$be1xx.get(_i);
    if (_oldtraces$MergeBasicExpr$be1xx.contains(_xx)) { }
    else { if (_xx.getbe1() != null) { _xx.getbe1().removetraces$MergeBasicExpr$be1(_xx); }  }
    _xx.setbe1(basicexpressionx);
  }
    basicexpressionx.settraces$MergeBasicExpr$be1(traces$MergeBasicExpr$be1xx);
      }


  public void addtraces$MergeBasicExpr$be1(BasicExpression basicexpressionx, MergeBasicExpr$trace traces$MergeBasicExpr$be1xx) 
  { if (basicexpressionx.gettraces$MergeBasicExpr$be1().contains(traces$MergeBasicExpr$be1xx)) { return; }
    if (traces$MergeBasicExpr$be1xx.getbe1() != null) { traces$MergeBasicExpr$be1xx.getbe1().removetraces$MergeBasicExpr$be1(traces$MergeBasicExpr$be1xx); }
  traces$MergeBasicExpr$be1xx.setbe1(basicexpressionx);
    basicexpressionx.addtraces$MergeBasicExpr$be1(traces$MergeBasicExpr$be1xx);
   }


  public void removetraces$MergeBasicExpr$be1(BasicExpression basicexpressionx, MergeBasicExpr$trace traces$MergeBasicExpr$be1xx) 
  { basicexpressionx.removetraces$MergeBasicExpr$be1(traces$MergeBasicExpr$be1xx);
      traces$MergeBasicExpr$be1xx.setbe1(null);
  }


 public void uniontraces$MergeBasicExpr$be1(BasicExpression basicexpressionx, List traces$MergeBasicExpr$be1x)
  { for (int _i = 0; _i < traces$MergeBasicExpr$be1x.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracextraces$MergeBasicExpr$be1 = (MergeBasicExpr$trace) traces$MergeBasicExpr$be1x.get(_i);
      addtraces$MergeBasicExpr$be1(basicexpressionx, mergebasicexpr$tracextraces$MergeBasicExpr$be1);
     } } 


 public void subtracttraces$MergeBasicExpr$be1(BasicExpression basicexpressionx, List traces$MergeBasicExpr$be1x)
  { for (int _i = 0; _i < traces$MergeBasicExpr$be1x.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracextraces$MergeBasicExpr$be1 = (MergeBasicExpr$trace) traces$MergeBasicExpr$be1x.get(_i);
      removetraces$MergeBasicExpr$be1(basicexpressionx, mergebasicexpr$tracextraces$MergeBasicExpr$be1);
     } } 


  public void settraces$CopyBasicExpr$be(BasicExpression basicexpressionx, List traces$CopyBasicExpr$bexx) 
  {   List _oldtraces$CopyBasicExpr$bexx = basicexpressionx.gettraces$CopyBasicExpr$be();
    for (int _j = 0; _j < _oldtraces$CopyBasicExpr$bexx.size(); _j++)
    { CopyBasicExpr$trace _yy = (CopyBasicExpr$trace) _oldtraces$CopyBasicExpr$bexx.get(_j);
      if (traces$CopyBasicExpr$bexx.contains(_yy)) { }
      else { _yy.setbe(null); }
    }
  for (int _i = 0; _i < traces$CopyBasicExpr$bexx.size(); _i++)
  { CopyBasicExpr$trace _xx = (CopyBasicExpr$trace) traces$CopyBasicExpr$bexx.get(_i);
    if (_oldtraces$CopyBasicExpr$bexx.contains(_xx)) { }
    else { if (_xx.getbe() != null) { _xx.getbe().removetraces$CopyBasicExpr$be(_xx); }  }
    _xx.setbe(basicexpressionx);
  }
    basicexpressionx.settraces$CopyBasicExpr$be(traces$CopyBasicExpr$bexx);
      }


  public void addtraces$CopyBasicExpr$be(BasicExpression basicexpressionx, CopyBasicExpr$trace traces$CopyBasicExpr$bexx) 
  { if (basicexpressionx.gettraces$CopyBasicExpr$be().contains(traces$CopyBasicExpr$bexx)) { return; }
    if (traces$CopyBasicExpr$bexx.getbe() != null) { traces$CopyBasicExpr$bexx.getbe().removetraces$CopyBasicExpr$be(traces$CopyBasicExpr$bexx); }
  traces$CopyBasicExpr$bexx.setbe(basicexpressionx);
    basicexpressionx.addtraces$CopyBasicExpr$be(traces$CopyBasicExpr$bexx);
   }


  public void removetraces$CopyBasicExpr$be(BasicExpression basicexpressionx, CopyBasicExpr$trace traces$CopyBasicExpr$bexx) 
  { basicexpressionx.removetraces$CopyBasicExpr$be(traces$CopyBasicExpr$bexx);
      traces$CopyBasicExpr$bexx.setbe(null);
  }


 public void uniontraces$CopyBasicExpr$be(BasicExpression basicexpressionx, List traces$CopyBasicExpr$bex)
  { for (int _i = 0; _i < traces$CopyBasicExpr$bex.size(); _i++)
    { CopyBasicExpr$trace copybasicexpr$tracextraces$CopyBasicExpr$be = (CopyBasicExpr$trace) traces$CopyBasicExpr$bex.get(_i);
      addtraces$CopyBasicExpr$be(basicexpressionx, copybasicexpr$tracextraces$CopyBasicExpr$be);
     } } 


 public void subtracttraces$CopyBasicExpr$be(BasicExpression basicexpressionx, List traces$CopyBasicExpr$bex)
  { for (int _i = 0; _i < traces$CopyBasicExpr$bex.size(); _i++)
    { CopyBasicExpr$trace copybasicexpr$tracextraces$CopyBasicExpr$be = (CopyBasicExpr$trace) traces$CopyBasicExpr$bex.get(_i);
      removetraces$CopyBasicExpr$be(basicexpressionx, copybasicexpr$tracextraces$CopyBasicExpr$be);
     } } 


public void setoperator(BinaryExpression binaryexpressionx, String operator_x) 
  { binaryexpressionx.setoperator(operator_x);
    }


  public void settraces$MergeBinaryExpr$bx(BinaryExpression binaryexpressionx, List traces$MergeBinaryExpr$bxxx) 
  {   List _oldtraces$MergeBinaryExpr$bxxx = binaryexpressionx.gettraces$MergeBinaryExpr$bx();
    for (int _j = 0; _j < _oldtraces$MergeBinaryExpr$bxxx.size(); _j++)
    { MergeBinaryExpr$trace _yy = (MergeBinaryExpr$trace) _oldtraces$MergeBinaryExpr$bxxx.get(_j);
      if (traces$MergeBinaryExpr$bxxx.contains(_yy)) { }
      else { _yy.setbx(null); }
    }
  for (int _i = 0; _i < traces$MergeBinaryExpr$bxxx.size(); _i++)
  { MergeBinaryExpr$trace _xx = (MergeBinaryExpr$trace) traces$MergeBinaryExpr$bxxx.get(_i);
    if (_oldtraces$MergeBinaryExpr$bxxx.contains(_xx)) { }
    else { if (_xx.getbx() != null) { _xx.getbx().removetraces$MergeBinaryExpr$bx(_xx); }  }
    _xx.setbx(binaryexpressionx);
  }
    binaryexpressionx.settraces$MergeBinaryExpr$bx(traces$MergeBinaryExpr$bxxx);
      }


  public void addtraces$MergeBinaryExpr$bx(BinaryExpression binaryexpressionx, MergeBinaryExpr$trace traces$MergeBinaryExpr$bxxx) 
  { if (binaryexpressionx.gettraces$MergeBinaryExpr$bx().contains(traces$MergeBinaryExpr$bxxx)) { return; }
    if (traces$MergeBinaryExpr$bxxx.getbx() != null) { traces$MergeBinaryExpr$bxxx.getbx().removetraces$MergeBinaryExpr$bx(traces$MergeBinaryExpr$bxxx); }
  traces$MergeBinaryExpr$bxxx.setbx(binaryexpressionx);
    binaryexpressionx.addtraces$MergeBinaryExpr$bx(traces$MergeBinaryExpr$bxxx);
   }


  public void removetraces$MergeBinaryExpr$bx(BinaryExpression binaryexpressionx, MergeBinaryExpr$trace traces$MergeBinaryExpr$bxxx) 
  { binaryexpressionx.removetraces$MergeBinaryExpr$bx(traces$MergeBinaryExpr$bxxx);
      traces$MergeBinaryExpr$bxxx.setbx(null);
  }


 public void uniontraces$MergeBinaryExpr$bx(BinaryExpression binaryexpressionx, List traces$MergeBinaryExpr$bxx)
  { for (int _i = 0; _i < traces$MergeBinaryExpr$bxx.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracextraces$MergeBinaryExpr$bx = (MergeBinaryExpr$trace) traces$MergeBinaryExpr$bxx.get(_i);
      addtraces$MergeBinaryExpr$bx(binaryexpressionx, mergebinaryexpr$tracextraces$MergeBinaryExpr$bx);
     } } 


 public void subtracttraces$MergeBinaryExpr$bx(BinaryExpression binaryexpressionx, List traces$MergeBinaryExpr$bxx)
  { for (int _i = 0; _i < traces$MergeBinaryExpr$bxx.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracextraces$MergeBinaryExpr$bx = (MergeBinaryExpr$trace) traces$MergeBinaryExpr$bxx.get(_i);
      removetraces$MergeBinaryExpr$bx(binaryexpressionx, mergebinaryexpr$tracextraces$MergeBinaryExpr$bx);
     } } 


  public void settraces$MergeBinaryExpr$bx1(BinaryExpression binaryexpressionx, List traces$MergeBinaryExpr$bx1xx) 
  {   List _oldtraces$MergeBinaryExpr$bx1xx = binaryexpressionx.gettraces$MergeBinaryExpr$bx1();
    for (int _j = 0; _j < _oldtraces$MergeBinaryExpr$bx1xx.size(); _j++)
    { MergeBinaryExpr$trace _yy = (MergeBinaryExpr$trace) _oldtraces$MergeBinaryExpr$bx1xx.get(_j);
      if (traces$MergeBinaryExpr$bx1xx.contains(_yy)) { }
      else { _yy.setbx1(null); }
    }
  for (int _i = 0; _i < traces$MergeBinaryExpr$bx1xx.size(); _i++)
  { MergeBinaryExpr$trace _xx = (MergeBinaryExpr$trace) traces$MergeBinaryExpr$bx1xx.get(_i);
    if (_oldtraces$MergeBinaryExpr$bx1xx.contains(_xx)) { }
    else { if (_xx.getbx1() != null) { _xx.getbx1().removetraces$MergeBinaryExpr$bx1(_xx); }  }
    _xx.setbx1(binaryexpressionx);
  }
    binaryexpressionx.settraces$MergeBinaryExpr$bx1(traces$MergeBinaryExpr$bx1xx);
      }


  public void addtraces$MergeBinaryExpr$bx1(BinaryExpression binaryexpressionx, MergeBinaryExpr$trace traces$MergeBinaryExpr$bx1xx) 
  { if (binaryexpressionx.gettraces$MergeBinaryExpr$bx1().contains(traces$MergeBinaryExpr$bx1xx)) { return; }
    if (traces$MergeBinaryExpr$bx1xx.getbx1() != null) { traces$MergeBinaryExpr$bx1xx.getbx1().removetraces$MergeBinaryExpr$bx1(traces$MergeBinaryExpr$bx1xx); }
  traces$MergeBinaryExpr$bx1xx.setbx1(binaryexpressionx);
    binaryexpressionx.addtraces$MergeBinaryExpr$bx1(traces$MergeBinaryExpr$bx1xx);
   }


  public void removetraces$MergeBinaryExpr$bx1(BinaryExpression binaryexpressionx, MergeBinaryExpr$trace traces$MergeBinaryExpr$bx1xx) 
  { binaryexpressionx.removetraces$MergeBinaryExpr$bx1(traces$MergeBinaryExpr$bx1xx);
      traces$MergeBinaryExpr$bx1xx.setbx1(null);
  }


 public void uniontraces$MergeBinaryExpr$bx1(BinaryExpression binaryexpressionx, List traces$MergeBinaryExpr$bx1x)
  { for (int _i = 0; _i < traces$MergeBinaryExpr$bx1x.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracextraces$MergeBinaryExpr$bx1 = (MergeBinaryExpr$trace) traces$MergeBinaryExpr$bx1x.get(_i);
      addtraces$MergeBinaryExpr$bx1(binaryexpressionx, mergebinaryexpr$tracextraces$MergeBinaryExpr$bx1);
     } } 


 public void subtracttraces$MergeBinaryExpr$bx1(BinaryExpression binaryexpressionx, List traces$MergeBinaryExpr$bx1x)
  { for (int _i = 0; _i < traces$MergeBinaryExpr$bx1x.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracextraces$MergeBinaryExpr$bx1 = (MergeBinaryExpr$trace) traces$MergeBinaryExpr$bx1x.get(_i);
      removetraces$MergeBinaryExpr$bx1(binaryexpressionx, mergebinaryexpr$tracextraces$MergeBinaryExpr$bx1);
     } } 


  public void settraces$CopyBinaryExpr$bx(BinaryExpression binaryexpressionx, List traces$CopyBinaryExpr$bxxx) 
  {   List _oldtraces$CopyBinaryExpr$bxxx = binaryexpressionx.gettraces$CopyBinaryExpr$bx();
    for (int _j = 0; _j < _oldtraces$CopyBinaryExpr$bxxx.size(); _j++)
    { CopyBinaryExpr$trace _yy = (CopyBinaryExpr$trace) _oldtraces$CopyBinaryExpr$bxxx.get(_j);
      if (traces$CopyBinaryExpr$bxxx.contains(_yy)) { }
      else { _yy.setbx(null); }
    }
  for (int _i = 0; _i < traces$CopyBinaryExpr$bxxx.size(); _i++)
  { CopyBinaryExpr$trace _xx = (CopyBinaryExpr$trace) traces$CopyBinaryExpr$bxxx.get(_i);
    if (_oldtraces$CopyBinaryExpr$bxxx.contains(_xx)) { }
    else { if (_xx.getbx() != null) { _xx.getbx().removetraces$CopyBinaryExpr$bx(_xx); }  }
    _xx.setbx(binaryexpressionx);
  }
    binaryexpressionx.settraces$CopyBinaryExpr$bx(traces$CopyBinaryExpr$bxxx);
      }


  public void addtraces$CopyBinaryExpr$bx(BinaryExpression binaryexpressionx, CopyBinaryExpr$trace traces$CopyBinaryExpr$bxxx) 
  { if (binaryexpressionx.gettraces$CopyBinaryExpr$bx().contains(traces$CopyBinaryExpr$bxxx)) { return; }
    if (traces$CopyBinaryExpr$bxxx.getbx() != null) { traces$CopyBinaryExpr$bxxx.getbx().removetraces$CopyBinaryExpr$bx(traces$CopyBinaryExpr$bxxx); }
  traces$CopyBinaryExpr$bxxx.setbx(binaryexpressionx);
    binaryexpressionx.addtraces$CopyBinaryExpr$bx(traces$CopyBinaryExpr$bxxx);
   }


  public void removetraces$CopyBinaryExpr$bx(BinaryExpression binaryexpressionx, CopyBinaryExpr$trace traces$CopyBinaryExpr$bxxx) 
  { binaryexpressionx.removetraces$CopyBinaryExpr$bx(traces$CopyBinaryExpr$bxxx);
      traces$CopyBinaryExpr$bxxx.setbx(null);
  }


 public void uniontraces$CopyBinaryExpr$bx(BinaryExpression binaryexpressionx, List traces$CopyBinaryExpr$bxx)
  { for (int _i = 0; _i < traces$CopyBinaryExpr$bxx.size(); _i++)
    { CopyBinaryExpr$trace copybinaryexpr$tracextraces$CopyBinaryExpr$bx = (CopyBinaryExpr$trace) traces$CopyBinaryExpr$bxx.get(_i);
      addtraces$CopyBinaryExpr$bx(binaryexpressionx, copybinaryexpr$tracextraces$CopyBinaryExpr$bx);
     } } 


 public void subtracttraces$CopyBinaryExpr$bx(BinaryExpression binaryexpressionx, List traces$CopyBinaryExpr$bxx)
  { for (int _i = 0; _i < traces$CopyBinaryExpr$bxx.size(); _i++)
    { CopyBinaryExpr$trace copybinaryexpr$tracextraces$CopyBinaryExpr$bx = (CopyBinaryExpr$trace) traces$CopyBinaryExpr$bxx.get(_i);
      removetraces$CopyBinaryExpr$bx(binaryexpressionx, copybinaryexpr$tracextraces$CopyBinaryExpr$bx);
     } } 


public void setlabel(Edge edgex, String label_x) 
  { edgex.setlabel(label_x);
    }


  public void settarget(Edge edgex, Expression targetxx) 
  {   if (edgex.gettarget() == targetxx) { return; }
    if (edgex.gettarget() != null)
    { Expression old_value = edgex.gettarget();
      old_value.removeincoming(edgex); } 
    targetxx.addincoming(edgex);
    edgex.settarget(targetxx);
      }


  public void setsource(Edge edgex, Expression sourcexx) 
  {   if (edgex.getsource() == sourcexx) { return; }
    if (edgex.getsource() != null)
    { Expression old_value = edgex.getsource();
      old_value.removeoutgoing(edgex); } 
    sourcexx.addoutgoing(edgex);
    edgex.setsource(sourcexx);
      }


  public void setbe(MergeBasicExpr$trace mergebasicexpr$tracex, BasicExpression bexx) 
  {   if (mergebasicexpr$tracex.getbe() == bexx) { return; }
    if (mergebasicexpr$tracex.getbe() != null)
    { BasicExpression old_value = mergebasicexpr$tracex.getbe();
      old_value.removetraces$MergeBasicExpr$be(mergebasicexpr$tracex); } 
    bexx.addtraces$MergeBasicExpr$be(mergebasicexpr$tracex);
    mergebasicexpr$tracex.setbe(bexx);
      }


  public void setbe1(MergeBasicExpr$trace mergebasicexpr$tracex, BasicExpression be1xx) 
  {   if (mergebasicexpr$tracex.getbe1() == be1xx) { return; }
    if (mergebasicexpr$tracex.getbe1() != null)
    { BasicExpression old_value = mergebasicexpr$tracex.getbe1();
      old_value.removetraces$MergeBasicExpr$be1(mergebasicexpr$tracex); } 
    be1xx.addtraces$MergeBasicExpr$be1(mergebasicexpr$tracex);
    mergebasicexpr$tracex.setbe1(be1xx);
      }


  public void setbe(CopyBasicExpr$trace copybasicexpr$tracex, BasicExpression bexx) 
  {   if (copybasicexpr$tracex.getbe() == bexx) { return; }
    if (copybasicexpr$tracex.getbe() != null)
    { BasicExpression old_value = copybasicexpr$tracex.getbe();
      old_value.removetraces$CopyBasicExpr$be(copybasicexpr$tracex); } 
    bexx.addtraces$CopyBasicExpr$be(copybasicexpr$tracex);
    copybasicexpr$tracex.setbe(bexx);
      }


  public void setbx(MergeBinaryExpr$trace mergebinaryexpr$tracex, BinaryExpression bxxx) 
  {   if (mergebinaryexpr$tracex.getbx() == bxxx) { return; }
    if (mergebinaryexpr$tracex.getbx() != null)
    { BinaryExpression old_value = mergebinaryexpr$tracex.getbx();
      old_value.removetraces$MergeBinaryExpr$bx(mergebinaryexpr$tracex); } 
    bxxx.addtraces$MergeBinaryExpr$bx(mergebinaryexpr$tracex);
    mergebinaryexpr$tracex.setbx(bxxx);
      }


  public void setbx1(MergeBinaryExpr$trace mergebinaryexpr$tracex, BinaryExpression bx1xx) 
  {   if (mergebinaryexpr$tracex.getbx1() == bx1xx) { return; }
    if (mergebinaryexpr$tracex.getbx1() != null)
    { BinaryExpression old_value = mergebinaryexpr$tracex.getbx1();
      old_value.removetraces$MergeBinaryExpr$bx1(mergebinaryexpr$tracex); } 
    bx1xx.addtraces$MergeBinaryExpr$bx1(mergebinaryexpr$tracex);
    mergebinaryexpr$tracex.setbx1(bx1xx);
      }


  public void setbx(CopyBinaryExpr$trace copybinaryexpr$tracex, BinaryExpression bxxx) 
  {   if (copybinaryexpr$tracex.getbx() == bxxx) { return; }
    if (copybinaryexpr$tracex.getbx() != null)
    { BinaryExpression old_value = copybinaryexpr$tracex.getbx();
      old_value.removetraces$CopyBinaryExpr$bx(copybinaryexpr$tracex); } 
    bxxx.addtraces$CopyBinaryExpr$bx(copybinaryexpr$tracex);
    copybinaryexpr$tracex.setbx(bxxx);
      }



  public void tau$cleanup1(BasicExpression basicexpressionx)
  {   basicexpressionx.tau$cleanup1();
   }

  public void tau$cleanup2(BinaryExpression binaryexpressionx)
  {   binaryexpressionx.tau$cleanup2();
   }

  public void tau$pres1(MergeBasicExpr$trace mergebasicexpr$tracex)
  {   //  if (!(!((mergebasicexpr$tracex.getbe() instanceof BasicExpression@pre) && (mergebasicexpr$tracex.getbe1() instanceof BasicExpression@pre) && !(mergebasicexpr$tracex.getbe().equals(mergebasicexpr$tracex.getbe1())) && mergebasicexpr$tracex.getbe().getname().equals(mergebasicexpr$tracex.getbe1().getname()) && mergebasicexpr$tracex.getbe().getvalue().equals(mergebasicexpr$tracex.getbe1().getvalue()) && mergebasicexpr$tracex.getbe().getoutgoing().size() > 0))) { return; } 
    mergebasicexpr$tracex.tau$pres1();
   }

  public  List AllMergeBasicExpr$tracetau$pres1test(List mergebasicexpr$tracexs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < mergebasicexpr$tracexs.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracex = (MergeBasicExpr$trace) mergebasicexpr$tracexs.get(_i);
      result.add(new Boolean(mergebasicexpr$tracex.tau$pres1test()));
    }
    return result; 
  }

 public static boolean tau$pres1search()
 { return MergeBasicExpr$trace.tau$pres1search(); }

  public void tau$pres2(MergeBasicExpr$trace mergebasicexpr$tracex)
  {   mergebasicexpr$tracex.tau$pres2();
   }

  public void tau$pres3(CopyBasicExpr$trace copybasicexpr$tracex)
  {   copybasicexpr$tracex.tau$pres3();
   }

  public void tau$pres4(MergeBinaryExpr$trace mergebinaryexpr$tracex)
  {   //  if (!(!((mergebinaryexpr$tracex.getbx() instanceof BinaryExpression@pre) && (mergebinaryexpr$tracex.getbx1() instanceof BinaryExpression@pre) && !(mergebinaryexpr$tracex.getbx().equals(mergebinaryexpr$tracex.getbx1())) && mergebinaryexpr$tracex.getbx().getoperator().equals(mergebinaryexpr$tracex.getbx1().getoperator()) && Set.equals(Edge.getAllsource(mergebinaryexpr$tracex.getbx().getincoming()),Edge.getAllsource(mergebinaryexpr$tracex.getbx1().getincoming())) && mergebinaryexpr$tracex.getbx().getincoming().size() > 0))) { return; } 
    mergebinaryexpr$tracex.tau$pres4();
   }

  public  List AllMergeBinaryExpr$tracetau$pres4test(List mergebinaryexpr$tracexs)
  { 
    List result = new Vector();
    for (int _i = 0; _i < mergebinaryexpr$tracexs.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracex = (MergeBinaryExpr$trace) mergebinaryexpr$tracexs.get(_i);
      result.add(new Boolean(mergebinaryexpr$tracex.tau$pres4test()));
    }
    return result; 
  }

 public static boolean tau$pres4search()
 { return MergeBinaryExpr$trace.tau$pres4search(); }

  public void tau$pres5(MergeBinaryExpr$trace mergebinaryexpr$tracex)
  {   mergebinaryexpr$tracex.tau$pres5();
   }

  public void tau$pres6(CopyBinaryExpr$trace copybinaryexpr$tracex)
  {   copybinaryexpr$tracex.tau$pres6();
   }



  public void killAllExpression(List expressionxx)
  { for (int _i = 0; _i < expressionxx.size(); _i++)
    { killExpression((Expression) expressionxx.get(_i)); }
  }

  public void killExpression(Expression expressionxx)
  { if (expressionxx == null) { return; }
   expressions.remove(expressionxx);
    Vector _1removedtargetEdge = new Vector();
    Vector _1removedsourceEdge = new Vector();
    Vector _1qrangetargetEdge = new Vector();
    _1qrangetargetEdge.addAll(expressionxx.getincoming());
    for (int _i = 0; _i < _1qrangetargetEdge.size(); _i++)
    { Edge edgex = (Edge) _1qrangetargetEdge.get(_i);
      if (edgex != null && expressionxx.equals(edgex.gettarget()))
      { _1removedtargetEdge.add(edgex);
        edgex.settarget(null);
      }
    }
    Vector _1qrangesourceEdge = new Vector();
    _1qrangesourceEdge.addAll(expressionxx.getoutgoing());
    for (int _i = 0; _i < _1qrangesourceEdge.size(); _i++)
    { Edge edgex = (Edge) _1qrangesourceEdge.get(_i);
      if (edgex != null && expressionxx.equals(edgex.getsource()))
      { _1removedsourceEdge.add(edgex);
        edgex.setsource(null);
      }
    }
    for (int _i = 0; _i < _1removedtargetEdge.size(); _i++)
    { killEdge((Edge) _1removedtargetEdge.get(_i)); }
    for (int _i = 0; _i < _1removedsourceEdge.size(); _i++)
    { killEdge((Edge) _1removedsourceEdge.get(_i)); }
  }

  public void killAbstractExpression(Expression expressionxx)
  {
    if (expressionxx instanceof BasicExpression)
    { killBasicExpression((BasicExpression) expressionxx); }
    if (expressionxx instanceof BinaryExpression)
    { killBinaryExpression((BinaryExpression) expressionxx); }
  }

  public void killAbstractExpression(List _l)
  { for (int _i = 0; _i < _l.size(); _i++)
    { Expression _e = (Expression) _l.get(_i);
      killAbstractExpression(_e);
    }
  }



  public void killAllBasicExpression(List basicexpressionxx)
  { for (int _i = 0; _i < basicexpressionxx.size(); _i++)
    { killBasicExpression((BasicExpression) basicexpressionxx.get(_i)); }
  }

  public void killBasicExpression(BasicExpression basicexpressionxx)
  { if (basicexpressionxx == null) { return; }
   basicexpressions.remove(basicexpressionxx);
    Vector _1removedbeMergeBasicExpr$trace = new Vector();
    Vector _1removedbe1MergeBasicExpr$trace = new Vector();
    Vector _1removedbeCopyBasicExpr$trace = new Vector();
    Vector _1qrangebeMergeBasicExpr$trace = new Vector();
    _1qrangebeMergeBasicExpr$trace.addAll(basicexpressionxx.gettraces$MergeBasicExpr$be());
    for (int _i = 0; _i < _1qrangebeMergeBasicExpr$trace.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracex = (MergeBasicExpr$trace) _1qrangebeMergeBasicExpr$trace.get(_i);
      if (mergebasicexpr$tracex != null && basicexpressionxx.equals(mergebasicexpr$tracex.getbe()))
      { _1removedbeMergeBasicExpr$trace.add(mergebasicexpr$tracex);
        mergebasicexpr$tracex.setbe(null);
      }
    }
    Vector _1qrangebe1MergeBasicExpr$trace = new Vector();
    _1qrangebe1MergeBasicExpr$trace.addAll(basicexpressionxx.gettraces$MergeBasicExpr$be1());
    for (int _i = 0; _i < _1qrangebe1MergeBasicExpr$trace.size(); _i++)
    { MergeBasicExpr$trace mergebasicexpr$tracex = (MergeBasicExpr$trace) _1qrangebe1MergeBasicExpr$trace.get(_i);
      if (mergebasicexpr$tracex != null && basicexpressionxx.equals(mergebasicexpr$tracex.getbe1()))
      { _1removedbe1MergeBasicExpr$trace.add(mergebasicexpr$tracex);
        mergebasicexpr$tracex.setbe1(null);
      }
    }
    Vector _1qrangebeCopyBasicExpr$trace = new Vector();
    _1qrangebeCopyBasicExpr$trace.addAll(basicexpressionxx.gettraces$CopyBasicExpr$be());
    for (int _i = 0; _i < _1qrangebeCopyBasicExpr$trace.size(); _i++)
    { CopyBasicExpr$trace copybasicexpr$tracex = (CopyBasicExpr$trace) _1qrangebeCopyBasicExpr$trace.get(_i);
      if (copybasicexpr$tracex != null && basicexpressionxx.equals(copybasicexpr$tracex.getbe()))
      { _1removedbeCopyBasicExpr$trace.add(copybasicexpr$tracex);
        copybasicexpr$tracex.setbe(null);
      }
    }
    for (int _i = 0; _i < _1removedbeMergeBasicExpr$trace.size(); _i++)
    { killMergeBasicExpr$trace((MergeBasicExpr$trace) _1removedbeMergeBasicExpr$trace.get(_i)); }
    for (int _i = 0; _i < _1removedbe1MergeBasicExpr$trace.size(); _i++)
    { killMergeBasicExpr$trace((MergeBasicExpr$trace) _1removedbe1MergeBasicExpr$trace.get(_i)); }
    for (int _i = 0; _i < _1removedbeCopyBasicExpr$trace.size(); _i++)
    { killCopyBasicExpr$trace((CopyBasicExpr$trace) _1removedbeCopyBasicExpr$trace.get(_i)); }
  killExpression(basicexpressionxx);
  }



  public void killAllBinaryExpression(List binaryexpressionxx)
  { for (int _i = 0; _i < binaryexpressionxx.size(); _i++)
    { killBinaryExpression((BinaryExpression) binaryexpressionxx.get(_i)); }
  }

  public void killBinaryExpression(BinaryExpression binaryexpressionxx)
  { if (binaryexpressionxx == null) { return; }
   binaryexpressions.remove(binaryexpressionxx);
    Vector _1removedbxMergeBinaryExpr$trace = new Vector();
    Vector _1removedbx1MergeBinaryExpr$trace = new Vector();
    Vector _1removedbxCopyBinaryExpr$trace = new Vector();
    Vector _1qrangebxMergeBinaryExpr$trace = new Vector();
    _1qrangebxMergeBinaryExpr$trace.addAll(binaryexpressionxx.gettraces$MergeBinaryExpr$bx());
    for (int _i = 0; _i < _1qrangebxMergeBinaryExpr$trace.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracex = (MergeBinaryExpr$trace) _1qrangebxMergeBinaryExpr$trace.get(_i);
      if (mergebinaryexpr$tracex != null && binaryexpressionxx.equals(mergebinaryexpr$tracex.getbx()))
      { _1removedbxMergeBinaryExpr$trace.add(mergebinaryexpr$tracex);
        mergebinaryexpr$tracex.setbx(null);
      }
    }
    Vector _1qrangebx1MergeBinaryExpr$trace = new Vector();
    _1qrangebx1MergeBinaryExpr$trace.addAll(binaryexpressionxx.gettraces$MergeBinaryExpr$bx1());
    for (int _i = 0; _i < _1qrangebx1MergeBinaryExpr$trace.size(); _i++)
    { MergeBinaryExpr$trace mergebinaryexpr$tracex = (MergeBinaryExpr$trace) _1qrangebx1MergeBinaryExpr$trace.get(_i);
      if (mergebinaryexpr$tracex != null && binaryexpressionxx.equals(mergebinaryexpr$tracex.getbx1()))
      { _1removedbx1MergeBinaryExpr$trace.add(mergebinaryexpr$tracex);
        mergebinaryexpr$tracex.setbx1(null);
      }
    }
    Vector _1qrangebxCopyBinaryExpr$trace = new Vector();
    _1qrangebxCopyBinaryExpr$trace.addAll(binaryexpressionxx.gettraces$CopyBinaryExpr$bx());
    for (int _i = 0; _i < _1qrangebxCopyBinaryExpr$trace.size(); _i++)
    { CopyBinaryExpr$trace copybinaryexpr$tracex = (CopyBinaryExpr$trace) _1qrangebxCopyBinaryExpr$trace.get(_i);
      if (copybinaryexpr$tracex != null && binaryexpressionxx.equals(copybinaryexpr$tracex.getbx()))
      { _1removedbxCopyBinaryExpr$trace.add(copybinaryexpr$tracex);
        copybinaryexpr$tracex.setbx(null);
      }
    }
    for (int _i = 0; _i < _1removedbxMergeBinaryExpr$trace.size(); _i++)
    { killMergeBinaryExpr$trace((MergeBinaryExpr$trace) _1removedbxMergeBinaryExpr$trace.get(_i)); }
    for (int _i = 0; _i < _1removedbx1MergeBinaryExpr$trace.size(); _i++)
    { killMergeBinaryExpr$trace((MergeBinaryExpr$trace) _1removedbx1MergeBinaryExpr$trace.get(_i)); }
    for (int _i = 0; _i < _1removedbxCopyBinaryExpr$trace.size(); _i++)
    { killCopyBinaryExpr$trace((CopyBinaryExpr$trace) _1removedbxCopyBinaryExpr$trace.get(_i)); }
  killExpression(binaryexpressionxx);
  }



  public void killAllEdge(List edgexx)
  { for (int _i = 0; _i < edgexx.size(); _i++)
    { killEdge((Edge) edgexx.get(_i)); }
  }

  public void killEdge(Edge edgexx)
  { if (edgexx == null) { return; }
   edges.remove(edgexx);
    Vector _2qrangeincomingExpression = new Vector();
    _2qrangeincomingExpression.add(edgexx.gettarget());
    for (int _i = 0; _i < _2qrangeincomingExpression.size(); _i++)
    { Expression expressionx = (Expression) _2qrangeincomingExpression.get(_i);
      if (expressionx != null && expressionx.getincoming().contains(edgexx))
      { removeincoming(expressionx,edgexx); }
    }
    Vector _2qrangeoutgoingExpression = new Vector();
    _2qrangeoutgoingExpression.add(edgexx.getsource());
    for (int _i = 0; _i < _2qrangeoutgoingExpression.size(); _i++)
    { Expression expressionx = (Expression) _2qrangeoutgoingExpression.get(_i);
      if (expressionx != null && expressionx.getoutgoing().contains(edgexx))
      { removeoutgoing(expressionx,edgexx); }
    }
  }



  public void killAllMergeBasicExpr$trace(List mergebasicexpr$tracexx)
  { for (int _i = 0; _i < mergebasicexpr$tracexx.size(); _i++)
    { killMergeBasicExpr$trace((MergeBasicExpr$trace) mergebasicexpr$tracexx.get(_i)); }
  }

  public void killMergeBasicExpr$trace(MergeBasicExpr$trace mergebasicexpr$tracexx)
  { if (mergebasicexpr$tracexx == null) { return; }
   mergebasicexpr$traces.remove(mergebasicexpr$tracexx);
    Vector _2qrangetraces$MergeBasicExpr$beBasicExpression = new Vector();
    _2qrangetraces$MergeBasicExpr$beBasicExpression.add(mergebasicexpr$tracexx.getbe());
    for (int _i = 0; _i < _2qrangetraces$MergeBasicExpr$beBasicExpression.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) _2qrangetraces$MergeBasicExpr$beBasicExpression.get(_i);
      if (basicexpressionx != null && basicexpressionx.gettraces$MergeBasicExpr$be().contains(mergebasicexpr$tracexx))
      { removetraces$MergeBasicExpr$be(basicexpressionx,mergebasicexpr$tracexx); }
    }
    Vector _2qrangetraces$MergeBasicExpr$be1BasicExpression = new Vector();
    _2qrangetraces$MergeBasicExpr$be1BasicExpression.add(mergebasicexpr$tracexx.getbe1());
    for (int _i = 0; _i < _2qrangetraces$MergeBasicExpr$be1BasicExpression.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) _2qrangetraces$MergeBasicExpr$be1BasicExpression.get(_i);
      if (basicexpressionx != null && basicexpressionx.gettraces$MergeBasicExpr$be1().contains(mergebasicexpr$tracexx))
      { removetraces$MergeBasicExpr$be1(basicexpressionx,mergebasicexpr$tracexx); }
    }
  }



  public void killAllCopyBasicExpr$trace(List copybasicexpr$tracexx)
  { for (int _i = 0; _i < copybasicexpr$tracexx.size(); _i++)
    { killCopyBasicExpr$trace((CopyBasicExpr$trace) copybasicexpr$tracexx.get(_i)); }
  }

  public void killCopyBasicExpr$trace(CopyBasicExpr$trace copybasicexpr$tracexx)
  { if (copybasicexpr$tracexx == null) { return; }
   copybasicexpr$traces.remove(copybasicexpr$tracexx);
    Vector _2qrangetraces$CopyBasicExpr$beBasicExpression = new Vector();
    _2qrangetraces$CopyBasicExpr$beBasicExpression.add(copybasicexpr$tracexx.getbe());
    for (int _i = 0; _i < _2qrangetraces$CopyBasicExpr$beBasicExpression.size(); _i++)
    { BasicExpression basicexpressionx = (BasicExpression) _2qrangetraces$CopyBasicExpr$beBasicExpression.get(_i);
      if (basicexpressionx != null && basicexpressionx.gettraces$CopyBasicExpr$be().contains(copybasicexpr$tracexx))
      { removetraces$CopyBasicExpr$be(basicexpressionx,copybasicexpr$tracexx); }
    }
  }



  public void killAllMergeBinaryExpr$trace(List mergebinaryexpr$tracexx)
  { for (int _i = 0; _i < mergebinaryexpr$tracexx.size(); _i++)
    { killMergeBinaryExpr$trace((MergeBinaryExpr$trace) mergebinaryexpr$tracexx.get(_i)); }
  }

  public void killMergeBinaryExpr$trace(MergeBinaryExpr$trace mergebinaryexpr$tracexx)
  { if (mergebinaryexpr$tracexx == null) { return; }
   mergebinaryexpr$traces.remove(mergebinaryexpr$tracexx);
    Vector _2qrangetraces$MergeBinaryExpr$bxBinaryExpression = new Vector();
    _2qrangetraces$MergeBinaryExpr$bxBinaryExpression.add(mergebinaryexpr$tracexx.getbx());
    for (int _i = 0; _i < _2qrangetraces$MergeBinaryExpr$bxBinaryExpression.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) _2qrangetraces$MergeBinaryExpr$bxBinaryExpression.get(_i);
      if (binaryexpressionx != null && binaryexpressionx.gettraces$MergeBinaryExpr$bx().contains(mergebinaryexpr$tracexx))
      { removetraces$MergeBinaryExpr$bx(binaryexpressionx,mergebinaryexpr$tracexx); }
    }
    Vector _2qrangetraces$MergeBinaryExpr$bx1BinaryExpression = new Vector();
    _2qrangetraces$MergeBinaryExpr$bx1BinaryExpression.add(mergebinaryexpr$tracexx.getbx1());
    for (int _i = 0; _i < _2qrangetraces$MergeBinaryExpr$bx1BinaryExpression.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) _2qrangetraces$MergeBinaryExpr$bx1BinaryExpression.get(_i);
      if (binaryexpressionx != null && binaryexpressionx.gettraces$MergeBinaryExpr$bx1().contains(mergebinaryexpr$tracexx))
      { removetraces$MergeBinaryExpr$bx1(binaryexpressionx,mergebinaryexpr$tracexx); }
    }
  }



  public void killAllCopyBinaryExpr$trace(List copybinaryexpr$tracexx)
  { for (int _i = 0; _i < copybinaryexpr$tracexx.size(); _i++)
    { killCopyBinaryExpr$trace((CopyBinaryExpr$trace) copybinaryexpr$tracexx.get(_i)); }
  }

  public void killCopyBinaryExpr$trace(CopyBinaryExpr$trace copybinaryexpr$tracexx)
  { if (copybinaryexpr$tracexx == null) { return; }
   copybinaryexpr$traces.remove(copybinaryexpr$tracexx);
    Vector _2qrangetraces$CopyBinaryExpr$bxBinaryExpression = new Vector();
    _2qrangetraces$CopyBinaryExpr$bxBinaryExpression.add(copybinaryexpr$tracexx.getbx());
    for (int _i = 0; _i < _2qrangetraces$CopyBinaryExpr$bxBinaryExpression.size(); _i++)
    { BinaryExpression binaryexpressionx = (BinaryExpression) _2qrangetraces$CopyBinaryExpr$bxBinaryExpression.get(_i);
      if (binaryexpressionx != null && binaryexpressionx.gettraces$CopyBinaryExpr$bx().contains(copybinaryexpr$tracexx))
      { removetraces$CopyBinaryExpr$bx(binaryexpressionx,copybinaryexpr$tracexx); }
    }
  }



  public void killAllTau$Pres(List tau$presxx)
  { for (int _i = 0; _i < tau$presxx.size(); _i++)
    { killTau$Pres((Tau$Pres) tau$presxx.get(_i)); }
  }

  public void killTau$Pres(Tau$Pres tau$presxx)
  { if (tau$presxx == null) { return; }
   tau$press.remove(tau$presxx);
  }



  public void killAllTau$Con(List tau$conxx)
  { for (int _i = 0; _i < tau$conxx.size(); _i++)
    { killTau$Con((Tau$Con) tau$conxx.get(_i)); }
  }

  public void killTau$Con(Tau$Con tau$conxx)
  { if (tau$conxx == null) { return; }
   tau$cons.remove(tau$conxx);
  }



  public void killAllTau$Cleanup(List tau$cleanupxx)
  { for (int _i = 0; _i < tau$cleanupxx.size(); _i++)
    { killTau$Cleanup((Tau$Cleanup) tau$cleanupxx.get(_i)); }
  }

  public void killTau$Cleanup(Tau$Cleanup tau$cleanupxx)
  { if (tau$cleanupxx == null) { return; }
   tau$cleanups.remove(tau$cleanupxx);
  }




  
  
  public void tau$Pres() 
  { 

    boolean tau$pres1_running;
  tau$pres1_running = true;
    while (tau$pres1_running) 
  { tau$pres1_running = MergeBasicExpr$trace.tau$pres1search(); }

    List _range59 = new Vector();
  _range59.addAll(Controller.inst().mergebasicexpr$traces);
  for (int _i58 = 0; _i58 < _range59.size(); _i58++)
  { MergeBasicExpr$trace loopvar_8 = (MergeBasicExpr$trace) _range59.get(_i58);
       Controller.inst().tau$pres2(loopvar_8);
  }
    List _range61 = new Vector();
  _range61.addAll(Controller.inst().copybasicexpr$traces);
  for (int _i60 = 0; _i60 < _range61.size(); _i60++)
  { CopyBasicExpr$trace loopvar_9 = (CopyBasicExpr$trace) _range61.get(_i60);
       Controller.inst().tau$pres3(loopvar_9);
  }
    boolean tau$pres4_running;
  tau$pres4_running = true;
    while (tau$pres4_running) 
  { tau$pres4_running = MergeBinaryExpr$trace.tau$pres4search(); }

    List _range63 = new Vector();
  _range63.addAll(Controller.inst().mergebinaryexpr$traces);
  for (int _i62 = 0; _i62 < _range63.size(); _i62++)
  { MergeBinaryExpr$trace loopvar_10 = (MergeBinaryExpr$trace) _range63.get(_i62);
       Controller.inst().tau$pres5(loopvar_10);
  }
    List _range65 = new Vector();
  _range65.addAll(Controller.inst().copybinaryexpr$traces);
  for (int _i64 = 0; _i64 < _range65.size(); _i64++)
  { CopyBinaryExpr$trace loopvar_11 = (CopyBinaryExpr$trace) _range65.get(_i64);
       Controller.inst().tau$pres6(loopvar_11);
  }

  }



  
  public void tau$Con() 
  { 

    List _range67 = new Vector();
  _range67.addAll(Controller.inst().basicexpressions);
  for (int _i66 = 0; _i66 < _range67.size(); _i66++)
  { BasicExpression be = (BasicExpression) _range67.get(_i66);
          String pre_name68 = be.getname();
      String pre_value69 = be.getvalue();
    List pre_outgoing70 = new Vector();
    pre_outgoing70.addAll(be.getoutgoing());
    List pre_traces$MergeBasicExpr$be71 = new Vector();
    pre_traces$MergeBasicExpr$be71.addAll(be.gettraces$MergeBasicExpr$be());

    List _range73 = new Vector();
  _range73.addAll(Controller.inst().basicexpressions);
  for (int _i72 = 0; _i72 < _range73.size(); _i72++)
  { BasicExpression be1 = (BasicExpression) _range73.get(_i72);
          String pre_name74 = be1.getname();
      String pre_value75 = be1.getvalue();
    List pre_outgoing76 = new Vector();
    pre_outgoing76.addAll(be1.getoutgoing());

     if (!(be.equals(be1))) {    if (pre_name68.equals(pre_name74)) {    if (pre_value69.equals(pre_value75)) {    if (pre_outgoing70.size() > 0) {    if (!(Set.exists_0(pre_traces$MergeBasicExpr$be71,be1))) {    MergeBasicExpr$trace tr$0 = new MergeBasicExpr$trace();
    Controller.inst().addMergeBasicExpr$trace(tr$0);
    Controller.inst().setbe(tr$0,be);
    Controller.inst().setbe1(tr$0,be1);
        List _edge_list77 = new Vector();
    _edge_list77.addAll(pre_outgoing76);
    for (int _ind78 = 0; _ind78 < _edge_list77.size(); _ind78++)
    { Edge e = (Edge) _edge_list77.get(_ind78);
      Controller.inst().addoutgoing(be,e);
    }
 }
 }
 }
 }
 }

  }
  }
    List _range80 = new Vector();
  _range80.addAll(Controller.inst().basicexpressions);
  for (int _i79 = 0; _i79 < _range80.size(); _i79++)
  { BasicExpression be = (BasicExpression) _range80.get(_i79);
        List pre_outgoing81 = new Vector();
    pre_outgoing81.addAll(be.getoutgoing());
    List pre_traces$CopyBasicExpr$be82 = new Vector();
    pre_traces$CopyBasicExpr$be82.addAll(be.gettraces$CopyBasicExpr$be());

     if (pre_outgoing81.size() > 0) {    if (!(Set.exists_1(pre_traces$CopyBasicExpr$be82))) {    CopyBasicExpr$trace tr$2 = new CopyBasicExpr$trace();
    Controller.inst().addCopyBasicExpr$trace(tr$2);
    Controller.inst().setbe(tr$2,be); }
 }

  }
    List _range84 = new Vector();
  _range84.addAll(Controller.inst().binaryexpressions);
  for (int _i83 = 0; _i83 < _range84.size(); _i83++)
  { BinaryExpression bx = (BinaryExpression) _range84.get(_i83);
          String pre_operator85 = bx.getoperator();
    List pre_incoming86 = new Vector();
    pre_incoming86.addAll(bx.getincoming());
    List pre_traces$MergeBinaryExpr$bx87 = new Vector();
    pre_traces$MergeBinaryExpr$bx87.addAll(bx.gettraces$MergeBinaryExpr$bx());

    List _range89 = new Vector();
  _range89.addAll(Controller.inst().binaryexpressions);
  for (int _i88 = 0; _i88 < _range89.size(); _i88++)
  { BinaryExpression bx1 = (BinaryExpression) _range89.get(_i88);
          String pre_operator90 = bx1.getoperator();
    List pre_incoming91 = new Vector();
    pre_incoming91.addAll(bx1.getincoming());
    List pre_outgoing92 = new Vector();
    pre_outgoing92.addAll(bx1.getoutgoing());

     if (!(bx.equals(bx1))) {    if (pre_operator85.equals(pre_operator90)) {    if (Set.equals(Edge.getAllsource(bx.getincoming()),Edge.getAllsource(bx1.getincoming()))) {    if (pre_incoming86.size() > 0) {    if (!(Set.exists_2(pre_traces$MergeBinaryExpr$bx87,bx1))) {    MergeBinaryExpr$trace tr$4 = new MergeBinaryExpr$trace();
    Controller.inst().addMergeBinaryExpr$trace(tr$4);
    Controller.inst().setbx(tr$4,bx);
    Controller.inst().setbx1(tr$4,bx1);
        List _edge_list93 = new Vector();
    _edge_list93.addAll(pre_incoming91);
    for (int _ind94 = 0; _ind94 < _edge_list93.size(); _ind94++)
    { Edge e = (Edge) _edge_list93.get(_ind94);
      Controller.inst().addincoming(bx,e);
    }

        List _edge_list95 = new Vector();
    _edge_list95.addAll(pre_outgoing92);
    for (int _ind96 = 0; _ind96 < _edge_list95.size(); _ind96++)
    { Edge f = (Edge) _edge_list95.get(_ind96);
      Controller.inst().addoutgoing(bx,f);
    }
 }
 }
 }
 }
 }

  }
  }
    List _range98 = new Vector();
  _range98.addAll(Controller.inst().binaryexpressions);
  for (int _i97 = 0; _i97 < _range98.size(); _i97++)
  { BinaryExpression bx = (BinaryExpression) _range98.get(_i97);
        List pre_incoming99 = new Vector();
    pre_incoming99.addAll(bx.getincoming());
    List pre_traces$CopyBinaryExpr$bx100 = new Vector();
    pre_traces$CopyBinaryExpr$bx100.addAll(bx.gettraces$CopyBinaryExpr$bx());

     if (pre_incoming99.size() > 0) {    if (!(Set.exists_3(pre_traces$CopyBinaryExpr$bx100))) {    CopyBinaryExpr$trace tr$6 = new CopyBinaryExpr$trace();
    Controller.inst().addCopyBinaryExpr$trace(tr$6);
    Controller.inst().setbx(tr$6,bx); }
 }

  }

  }



  
  public void tau$Cleanup() 
  { 

    List _range102 = new Vector();
  _range102.addAll(Controller.inst().basicexpressions);
  for (int _i101 = 0; _i101 < _range102.size(); _i101++)
  { BasicExpression loopvar_12 = (BasicExpression) _range102.get(_i101);
       Controller.inst().tau$cleanup1(loopvar_12);
  }
    List _range104 = new Vector();
  _range104.addAll(Controller.inst().binaryexpressions);
  for (int _i103 = 0; _i103 < _range104.size(); _i103++)
  { BinaryExpression loopvar_13 = (BinaryExpression) _range104.get(_i103);
       Controller.inst().tau$cleanup2(loopvar_13);
  }

  }


 
}



