import java.io.*; 

public class PetriTestGen
{ public static final int dim = 3333;
  // Number of places = 2*dim, transitions = dim
  // dim = 3 => n = 10, dim = 33 => n = 100, dim = 333 => n = 1000, etc. 

  public static void main(String[] args)
  { File file = new File("./petritest.txt");
    try
    { PrintWriter out = new PrintWriter(
                              new BufferedWriter(
                                   new FileWriter(file)));
      writeModel(out); 
      out.close();
    }
    catch (IOException ex)
    { System.out.println("Error generating test"); }
  } 

  public static void writeModel(PrintWriter out)
  { String netname = "n"; 
    out.println(netname + " : Net"); 
    out.println(netname + ".netId = \"n\""); 

    for (int i = 1; i <= 2*dim; i++)
    { String placename = "p" + i;
      out.println(placename  + " : Place");
      out.println(placename + ".name = \"" + placename + "\""); 
      out.println(placename + ".placeId = \"" + placename + "\""); 
      out.println(placename + " : n.places"); 
    } 

    for (int i = 1; i <= dim; i++)
    { String cname = "t" + i;
      out.println(cname + " : Transition");
      out.println(cname + ".name = \"" + cname + "\""); 
      out.println(cname + ".transitionId = \"" + cname + "\"");
      out.println("p" + i + " : " + cname + ".src"); 
      out.println("p" + (2*i) + " : " + cname + ".dst");
      out.println(cname + " : n.transitions");  
    } 
  } 

}